﻿B4J=true
Group=Default Group\SA Comms
ModulesStructureVersion=1
Type=StaticCode
Version=10
@EndOfDesignText@
'Static code module
'This module does all the heavy lifting. It controls the TinySA Ultra, 
'  data formatting and results storage
' It also provides a list of the commands that the TinySA Ultra has formatted
'  as a map, however the map isn't used, but it's there if you need it
'--------------------------------------------------------------------------------------------
Sub Process_Globals
	Type band_stats_Type( _
						unixEpoch 			As Long, _
						TriggerType 		As Int, _
						MeanSignal_dBm 		As Float, _
						MaxSignal_dBm		As Float, _
						MinSignal_dBm 		As Float _
						)
						
	Private bandStats As band_stats_Type
	Private bandStatsValueArray(1000) As Float
	Public TriggerType0(50) As Int
	Public TriggerType1(50) As Int
					
	Type bandLogRecord_Type( _
							UnixEpoch            As String, _
							SignalSourceID       As Int, _
							MonitorChRec_ID      As Int, _
							TriggerType          As Int, _
							MeanSignal_dBm       As Float, _
							MaxSignal_dBm        As Float, _
							MinSignal_dBm		 As Float, _
							ExcptnDurationMax1   As Int, _
							ExcptnDurationMax2   As Int, _
							ExcptnDurationMin1   As Int, _
							ExcptnDurationMin2   As Int, _
							ExcptnDurationNoSig  As Int, _
							MaxHysterysis 		 As Float, _
							MinHysterysis 		 As Float _ 
							)
	
	Public bandLogRecord(50) As bandLogRecord_Type
	
	Type bandLogRecordTemp_Type( _
							TriggerType          As Int, _
							MeanSignal_dBm       As Float, _
							MaxSignal_dBm        As Float, _
							MinSignal_dBm		 As Float _
							)
		
	Public bandLogRecordTemp As bandLogRecordTemp_Type
	
	Type bandExcptTimers_Type( _
							Max1Time           As Long, _
							Max2Time           As Long, _
							Min1Time           As Long, _
							Min2Time           As Long, _
							NoSignalTime	   As Long _
							)
								
	Private startExceptionArray(50) As bandExcptTimers_Type

	Public const max1Bit 	As Int = 1
	Public const max2Bit 	As Int = 2
	Public const min1Bit 	As Int = 4
	Public const min2Bit 	As Int = 8
	Public const noSigBit	As Int = 16
	Public const startTriggerBit As Int = 0x1000000
	Public const routineScanBit  As Int = 0x2000000

	Type bandExceptionIndex_Type( _
		tblBandExceptionDataRunIndex As Int, _
		StartUnixEpoch As Long, _
		StartDateTimeUTC As String, _
		EndUnixEpoch As Long, _
		EndDateTimeUTC As String, _
		SignalSource_ID As Int, _
		Comment As String, _
		Details As String, _
		Deleted As Int)
		
		
	Public bandExceptionIndex As bandExceptionIndex_Type

	Private fx As JFX
	Private xui As XUI
	Dim commMap As Map
	Private cmd As String
	Private commandStr As String
	Private outArrayCount As Int
	Private scanResult As List
	Private scanCompleteSa As Boolean
	Private noBandPointsFound As Int
	Private BandMonRecord(12) As Object

	Private bList As List
	Private tempStr As String
	Private sf As StringFunctions
	Private bandNo As Int
	Public currentStart As Float
	Public CurrentStop As Float
	Public bandIndex As Int
	Public bandIndexLast As Int
	Public noAverageCount As Int
	Public averageCompleteFlag As Boolean
	Public totalScans As Int
	Private noOfPackets As Int
	Private sb As StringBuilder
	Public charset As String = "UTF8"

	Private scanListIndex As Int
	Private scanDataStreamText As String
	Private noValidScanLines As Int
	Public firstAvgDone As Boolean
	
	Public errorCount As Int
	Public runCount As Int
	Public replyError As Boolean
	
	Public AvgStartTicks As Long
	Public AverageEndTicks As Long
	Dim AverageDelta_ms As Int
	
	Public ScanStartTicks As Long
	Public ScanEndTicks As Long
	Public ScanMaxTicks As Long
	Dim ScanDelta_ms As Int
	
	Private Toast As clXToastMessage
End Sub


'--------------------------------------------------------------------------------------------
Public Sub initialize
	scanResult.Initialize
	Toast.Initialize(Main.MainForm.RootPane)
	Toast.SetTMPosition(Toast.TMPOS_BOTTOM)
	Toast.SetTMDuration(1000, 2000)
	Toast.SetTMBackground(0xFFFFE100, 2, 0xFF000000, 3)
	Toast.SetTMTextProp(36, 1, 1, xui.Color_Red)
	bandStats.Initialize
	bandExceptionIndex.Initialize
	clearMultiBandScanRecord(1000000)
	sb.Initialize
	bList.Initialize
End Sub


'--------------------------------------------------------------------------------------------
public Sub initComMap
	commMap.Initialize

	commMap.Put("bulk", 5) 			'send by tinySA when in auto refresh mode format: "bulk\r\n{X}{Y}{Width}{Height}{Pixeldata}\r\n" where all numbers are binary coded 2 bytes little endian. The Pixeldata Is encoded As 2 bytes per pixel
	commMap.Put("time", -3) 		'sets/gets SA time usage: time {[y|m|d|h|min|sec] 0-99} or {b 0xYYMMDD 0xHHMMSS}  Result = 2000/01/15 00:22:48
	commMap.Put("dac", -1)			'sets or dumps the frequency level correction table usage: correction [0..9 {frequency} {level}]
	commMap.Put("nf", -1)			'nf value ??
	commMap.Put("saveconfig", 0)	'Saves the congig data in SA memory usage: saveconfig
	commMap.Put("clearconfig", 0)  	'Clear config data ??
	commMap.Put("zero", -1)			'Sets/gets zeo dBm level
	commMap.Put("sweep", -3)  		'set sweep boundaries or execute a sweep usage: sweep [ ( start|stop|center|span|cw {frequency} ) | ( {start(Hz)} {stop(Hz)} [0..290] ) ] sweep without arguments lists the current sweep settings", the frequencies specified should be within the permissible range. The sweep commands apply both To input And output modes
									' Example sweep 533M 539M 21  Start = 533 Stop = 539 No Points = 21
	commMap.Put("pause", 1)			'pauses the sweep and sets the measurement frequency usage: freq {frequency}
	commMap.Put("resume", 0)		'resumes the sweeping in either input or output mode usage: resume
	commMap.Put("wait", 0)			'Just pauses the SA sweep
	commMap.Put("repeat", 0)      	'Repeats a sweep ??
	commMap.Put("status", 0)		'Shows running status
	commMap.Put("caloutput", 1)   	'disables or sets the caloutput to a specified frequency in MHz usage: caloutput off|30|15|10|4|3|2|1
	commMap.Put("save", 1)			'saves the current setting to a preset usage: save 0..4 where 0 is the startup preset
	commMap.Put("recall", 1)		'Same as load - loads a previously stored preset usage: load 0..4 where 0 is the startup preset
	commMap.Put("trace", 2)			'Displays all or one trace information or sets trace related information usage: trace [ {0..2} | dBm|dBmV|dBuV|V|W |store|clear|subtract | (scale|reflevel) auto|{level}
	commMap.Put("trigger", 2)		'sets the trigger type or level usage: trigger auto|normal|single|{level(dBm)} the trigger level is always set in dBm
	commMap.Put("marker",	1)		'sets or dumps marker info usage: marker {id} on|off|peak|{freq}|{index} where id=1..4 index=0..num_points-1 Merker levels will use the selected unit Marker peak will activate the marker (if not done already)", position the marker on the strongest signal And display the marker info The frequency must be within the selected sweep range
	commMap.Put("line", 1)        	'Sets a dBm line on the display usage line off|level
	commMap.Put("usart_cfg", 0)		'Reports baud rate
	commMap.Put("vbat_offset", 0)	'Reports sets vbat offset?
	commMap.Put("color", -1)  		'sets or dumps the colors used usage: color [{id} {rgb24}]
	commMap.Put("if", -1)			'Sets if {975M..979M} sets the IF to automatic or a specific value usage: if ( 0 | 433M..435M ) where 0 means automatic
	commMap.Put("if1", -1)			'Sets if1 {975M..979M}sets the IF to automatic or a specific value usage: if ( 0 | 433M..435M )where 0 means automatic
	commMap.Put("lna2", -1)			'Sets the LNA Gain 0..7 | Auto
	commMap.Put("agc", -1)			'Sets the AGC  0..7 | Auto
	commMap.Put("actual_freq", 0) 	'Gets actual frequency of ??
	commMap.Put("freq_corr", -1)  	'Gets sets frequency adjust ppb
	commMap.Put("attenuate", -1)  	'Set gat Attenuate 0..31|auto
	commMap.Put("trace reflevel", -1)  	'Set reference level usage trace reflevel (auto|{level})
	commMap.Put("level", -1)		'Set the output level -76..13 Not all values in the range are available
	commMap.Put("sweeptime", -1)	'sets the sweeptime usage: sweep {time(Seconds)}the time specified may end in a letter where m=mili and u=micro commMap.Put("leveloffset", 	'sets or dumps the level calibration data usage: leveloffset low|high|switch [output] {error} For the output corrections first ensure correct output levels at maximum output level. For the low output set the output to -50dBm and measure and correct the level with "leveloffset switch error" where For all output leveloffset commands measure the level with the leveloffset to zero and calculate error = measured level - specified level
	commMap.Put("levelchange", -1) 	'sets the output level delta for low output mode level sweep usage: levelchange -70..+70 commMap.Put("modulation",
	commMap.Put("rbw", -1)			'sets the rbw to either automatic or a specific value usage: rbw 0.2..850|autthe number specifies the target rbw in kHz
	commMap.Put("mode", -1)			'Sets mode [low] input|output
	commMap.Put("spur", -1)			'enables or disables spur reduction usage: spur on|off
	commMap.Put("lna", -1)			'LNA on or off  lna off|on
	commMap.Put("direct", -2)     	'set direct{start|stop|on|off} {freq(Hz)}
	commMap.Put("ultra", -1)		'Sets up ultra mode  ultra off|on|auto|start|harm {freq}
	commMap.Put("load", 1)			'loads a previously stored preset usage: load 0..4 where 0 is the startup preset
	commMap.Put("ext_gain", -1)   	'sets the external attenuation/amplification usage: ext_gain -100..100 Works in both input and output mode
	commMap.Put("output", -1)     	'Set output on|off|normal|mixer
	commMap.Put("deviceid", -1)		'Set get device ID deviceid {integer}
	commMap.Put("correction", -1) 	'correction sets or dumps the frequency level correction table usage: correction [0..9 {frequency} {level}]
	commMap.Put("calc", -1)			'sets or cancels one of the measurement modes usage: calc off|minh|maxh|maxd|aver4|aver16|quasip the commands are the same as those listed in the MEASURE menu
	commMap.Put("menu", -4)			'The menu command can be used to activate any menu item. usage: menu {#} [{#} [{#} [{#}]]] where # is the menu entry number starting with 1 at the top. Example: menu 6 2 will toggle the waterfall option
	commMap.Put("text", -1)			'text specifies the text entry for the active keypad usage: text keypadtext where keypadtext is the text used  Example: text 12M    Currently does not work for entering file names
	commMap.Put("remark", 0)		'does nothing
	commMap.Put("Other", 0)			'Not a command
	commMap.Put("version", 0) 		'Outputs version info
	commMap.Put("reset", 0)			'Reset the unit to factory
	commMap.Put("data", -1)			'Select data 0..2  ?What data
	commMap.Put("frequencies", 0)	'frequencies dumps the frequencies used by the last sweep    usage: frequencies
	commMap.Put("scan", -3) 		'scan     performs a scan and optionally outputs the measured data     usage: scan {start(Hz)} {stop(Hz)} [points] [outmask]   where the outmask is a binary OR of 1=frequencies", 2=measured data", 4=stored data and points is maximum 290
	commMap.Put("hop", -4)			' (Ultra only)  measures the input level at each of the requested frequencies usage: hop {start(Hz)} {stop(Hz)} {step(Hz) | points} [outmask] If the 3rd parameter is below 450 it is assumed to be points", otherwise as step frequency Outmask selects if the frequency (1) or level (2) is output.
	commMap.Put("scanraw", -3)		'performs a scan of unlimited amount of points and send the data in binary form usage: scanraw {start(Hz)} {stop(Hz)} [points] The measured data is the level in dBm and is send as '{' ('x' MSB LSB)*points '}'. To get the dBm level from the 16 bit data", divide by 32 and subtract 128.
	commMap.Put("test", 0)			'Don't know
	commMap.Put("touchcal", 0)		'Start screen touch cal
	commMap.Put("touchtest", 0)   	'Draws stuf on screen
	commMap.Put("usart", 0)			'???
	commMap.Put("capture", 0)		'capture requests a screen dump to be send in binary format of 320x240 pixels of each 2 bytes
	commMap.Put("refresh", -1)		'enables/disables the auto refresh mode Usage refresh on|off
	commMap.Put("touch",  -2)		'sends the coordinates of a touchusage: touch {X coordinate} {Y coordinate} The upper left corner of the screen is "0 0"
	commMap.Put("release", 0)		'signals a removal of the touch usage: release
	commMap.Put("vbat", 0)			'Displays batt voltage in mV
	commMap.Put("help", 0)			'Lists commands
	commMap.Put("info",	0)			'Lists device H/W software data
	commMap.Put("selftest", 1)		'performs one or all selftests usage: selftest 0  does all or  1..9
	commMap.Put("sd_list", 0)		'List sd card contents
	commMap.Put("sd_read", 1)		'Read SD card file
	commMap.Put("sd_delete", 1) 	'Delete sd card file
	commMap.Put("threads", 0)		'List threads
End Sub


'--------------------------------------------------------------------------------------------
'This function sets the parameters common to all bands
' The function sends out commands and waits for a return string from the SA before proceeding
' with the next one.
Public Sub setAnalyserConfig(lna As String, lnaGain As String, Attenuator As String, RBW As String, RefLevel As String, NoPoint As Int)
	' Pause the TinySA
	Main.dataReceivedFlag = False
	cmd = "pause"
	commandStr = cmd & " "
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
	Main.dataReceivedFlag = False
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Log(commandStr)
	
	'---------------------------------------------------------
	' Set the lna on or off
	Main.dataReceivedFlag = False
	cmd = "lna"
	commandStr = cmd & " " & lna.ToLowerCase.Trim
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
	Main.dataReceivedFlag = False
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Log(commandStr)
	
	'---------------------------------------------------------
	'Set the Lna Gain
	Main.dataReceivedFlag = False
	cmd = "lna2"
	commandStr = cmd & " " & lnaGain.ToLowerCase.Trim
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
	Main.dataReceivedFlag = False
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Log(commandStr)
	
	'---------------------------------------------------------
	' Set the Attenuator Gain
	Main.dataReceivedFlag = False
	cmd = "attenuate"
	commandStr = cmd & " " & Attenuator.ToLowerCase.Trim
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(1)
	Loop
	Main.dataReceivedFlag = False
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Log(commandStr)

	'---------------------------------------------------------
	'Set the Realt Time Bandwidth
	Main.dataReceivedFlag = False
	cmd = "rbw"
	
	'look up the allowed rbw parameter vale from the map
	commandStr = cmd & " " & Main.rbwComboMap.Get(RBW)
	Main.writeCmdSerial(commandStr)
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
	Main.dataReceivedFlag = False
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Log(commandStr)

'---------------------------------------------------------	
	'Set theReference Level
	Main.dataReceivedFlag = False
	cmd = "trace reflevel"
	commandStr = "trace reflevel " & RefLevel.ToLowerCase.Trim
	Main.writeCmdSerial(commandStr)
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
	Main.dataReceivedFlag = False
	
'	Log(commandStr)
	
	Sleep(20)
	If replyError = True Then
		Return
	End If
'	Main.timeStampListB4j.Clear
End Sub


'--------------------------------------------------------------------------------------------
'Snds a reset to the TinySA
Public Sub resetSA
	Main.dataReceivedFlag = False
	cmd = "reset"
	commandStr = cmd & " "
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(2)
	Loop
End Sub


'--------------------------------------------------------------------------------------------
'Pauses or resumes the scanning of the tinySA
Public Sub setSA_RunStop(stateRun As Boolean)
	Main.dataReceivedFlag = False
	
	If stateRun = True Then
		' Run the TinySA
		cmd = "resume"
	Else
		' Pause the TinySA
		cmd = "pause"
	End If
	
	commandStr = cmd & " "
	Main.writeCmdSerial(commandStr)
	
	Do While Main.dataReceivedFlag = False
		Sleep(1)
	Loop
	
	Sleep(20)
End Sub


'--------------------------------------------------------------------------------------------
'This sub checks the returns from commands that do no return data streams
'If it finds the word "usage:" this means the incorrect parameters have been 
'sent to the SA.
Private Sub checkReplyForErrorsShortCmds(token As String)
	Dim strTemp As String
	
	strTemp = tempStr.Trim
	token   = token.Trim

	If Not(strTemp.CompareTo(token) = 0 Or strTemp.CompareTo("ch>") = 0) Then
		If strTemp.Contains("usage:") Then
			replyError = True
			Log("No Match " & strTemp)
		End If
	End If
End Sub


'--------------------------------------------------------------------------------------------
'This sub is called from the setial port AStream_NewData. It converts the raw byte buffer int0
' a string and then selects the check based on the command string that was sent (cmd)
' It checks the reply and then if all good it sets the dataReceived flag True which
' is used by the command sendin subs to step on or in the case  of a data stream command
' like "scan" i processes the returned data stream using the sub getScanListFromSaResult.
' The SA outputs a prompt "ch>" in a sequence. These have to be removed from the scan command
' reply before processing the stream data. The chCount flag is used for this.
public Sub processCmdRx(Buffer() As Byte)
'	Log(BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
	replyError = False
	tempStr = BytesToString(Buffer, 0, Buffer.Length, "UTF8")
'	Log("Temp Str: " & tempStr)
	Select cmd
		Case "pause"
			checkReplyForErrorsShortCmds("pause")
			Main.dataReceivedFlag = True
		Case "lna"
			checkReplyForErrorsShortCmds("lna")
			Main.dataReceivedFlag = True
		Case "lna2"
			checkReplyForErrorsShortCmds("lna2")
			Main.dataReceivedFlag = True
		Case "attenuate"
			checkReplyForErrorsShortCmds("attenuate")
			Main.dataReceivedFlag = True
		Case "rbw"
			checkReplyForErrorsShortCmds("rbw")
			Main.dataReceivedFlag = True
		Case "trace reflevel"
			checkReplyForErrorsShortCmds("trace reflevel")
			Main.dataReceivedFlag = True
		Case "resume"	
			checkReplyForErrorsShortCmds("resume")
			Main.dataReceivedFlag = True
		Case "scan"	
'			Log(tempStr)
			cleanUpScanData(Buffer)
			Main.dataReceivedFlag = True
	End Select
	
	'Signal Data received for the command loop

End Sub


'--------------------------------------------------------------------------------------------
Private Sub cleanUpScanData(buffer() As Byte)
	Dim newDataStart As Int = sb.Length
	sb.Append(BytesToString(buffer, 0, buffer.Length, charset))
	Dim s As String = sb.ToString
	Dim start As Int = 0
	
	For i = newDataStart To s.Length - 1
		noOfPackets = noOfPackets + 1
		Dim c As Char = s.CharAt(i)
		If i = 0 And c = Chr(10) Then '\n...
			start = 1 'might be a broken end of line character
			Continue
		End If
		If c = Chr(10) Then '\n
'			CallSubDelayed2(Me, "checkAndProcessScanLine", s.SubString2(start, i))
			checkAndProcessScanLine(s.SubString2(start, i))
			start = i + 1
		Else If c = Chr(13) Then '\r
'			CallSubDelayed2(Me, "checkAndProcessScanLine", s.SubString2(start, i))
			checkAndProcessScanLine(s.SubString2(start, i))
			If i < s.Length - 1 And s.CharAt(i + 1) = Chr(10) Then '\r\n
				i = i + 1
			End If
			start = i + 1
		End If
	Next
	If start > 0 Then sb.Remove(0, start)
End Sub


'--------------------------------------------------------------------------------------------
private Sub checkAndProcessScanLine(scanLineStr As String)
	If scanLineStr.Contains("level") Or scanLineStr.Contains("scan") Then
		Return
	End If

	scanDataStreamText = scanDataStreamText  & Chr(10) & scanLineStr
	noValidScanLines = noValidScanLines + 1

	If noValidScanLines = Main.Band_Data.getBandNoPointsArray(bandIndex) Then
		noValidScanLines = 0
		'Process the data	
		getScanListFromSaResult(scanDataStreamText)
		noBandPointsFound = 0
		scanCompleteSa = True
	End If
	Return
End Sub


'--------------------------------------------------------------------------------------------
Public Sub preAverageStartInit
	Main.clearprogAverage
	Main.progBandScan.Progress = 0

	Main.AllScansCompleteFlag = False
	
	Main.debugStr = ""
	
	bandLogRecordInit

	'Clear the average accumulator array and zero its index
	clearMultiBandScanRecord(Main.Band_Data.noPointsInTot)
	scanListIndex = 0
	bandIndex = 0
	
	'Clear the number of points completed
	Main.Band_Data.noPointsComplet = 0
End Sub


''======================================================================================================
'Sub saDataReceived() As ResumableSub
'	Sleep(10)
''	#IF LOGGING_ON
''	Log("saDataReceived  - Main " & DateTime.Time(DateTime.now))
''	#END IF
'	Return True
'End Sub


''======================================================================================================
'Sub saAllScansComplete() As ResumableSub
'	Sleep(10)
'	#IF LOGGING_ON
''	Log("Can Continue 2  - Main " & DateTime.Date(DateTime.now))
'	#END IF
'	Return True
'End Sub


'======================================================================================================
Public Sub testScan As ResumableSub
	Private sleepTime As Int = 5
	Dim timeout As Int = 10000 / sleepTime
	bandIndex = 0
	noAverageCount = 1
	bList = Main.Band_Data.MbandList
		
	'Get the band config data
	bList = Main.Band_Data.MbandList
	
	BandMonRecord = bList.Get(bandIndex)
		
	'Send a scan command to the TSA (serial port) for the specified band
	scanBand(BandMonRecord)

	'Wait For saDataReceived - From AStream_NewData => scanCompleteSa
	Do While scanCompleteSa = False And timeout > 0
		timeout = timeout - 1
		Sleep(2)
	Loop
	Return True
End Sub


'======================================================================================================
Public Sub scanSampleTickProcess
	Private sleepTime As Int = 2
	Dim timeout As Int = 1000 / sleepTime

	If noAverageCount = Main.Band_Data.SigSrcCurrentRecord.NoSpectrumAvgs Then
		ScanMaxTicks = 0
		processExceptions
		firstAvgDone = True
		
		create_dBm_CurveForPlotting
		Main.Band_Data.plotSpectrumOnMainGraph
		Main.Band_Data.plotBarGraphMain

		Sleep(0) 'Call UI

		Main.singleScannInitiated = True
		Main.AllProcessingComplete = True
		averageCompleteFlag = True
		
		preAverageStartInit
		noAverageCount = 0
		
		' Calc the total average time
		AverageEndTicks =  DateTime.Now
		AverageDelta_ms = AverageEndTicks - AvgStartTicks
		Main.lblAverageTime.Text = NumberFormat(AverageDelta_ms / 1000, 1,2) & "s"
	Else
		If bandIndex = 0 And noAverageCount = 0 Then
			AvgStartTicks = DateTime.Now
		End If
		
    	'Get the band config data 
		bList = Main.Band_Data.MbandList
	
		BandMonRecord = bList.Get(bandIndex)
		
		bandIndex = bandIndex + 1
		bandIndexLast = bandIndex - 1
		If bandIndex = bList.Size Then
			bandIndex = 0
			noAverageCount = noAverageCount + 1
			updateAverageProgressBar
		End If
		
		'Send a scan command to the TSA (serial port) for the specified band
		ScanStartTicks = DateTime.Now
		scanBand(BandMonRecord)
		
		'Wait For saDataReceived - From AStream_NewData => scanCompleteSa 
		Do While scanCompleteSa = False
			Sleep(2)
			timeout = timeout - 1
		Loop
		
		' Calc the scan time max for this average run
		ScanEndTicks = DateTime.Now
		ScanDelta_ms = ScanEndTicks - ScanStartTicks
		
		If ScanDelta_ms > ScanMaxTicks Then
			ScanMaxTicks = ScanDelta_ms
		End If
		
		Main.lblScanTime.Text = NumberFormat(ScanMaxTicks / 1000, 1, 3) & "s"
		
		If timeout = 0 Then 'Never gets here 
			Log("Timeout " & "scanCompleteSa = " & scanCompleteSa)
		End If
	End If
End Sub


'--------------------------------------------------------------------------------------------
Public Sub scanBand(BandMonRec() As Object)
	Main.progBandScan.Progress = 0
	scanCompleteSa = False
	Main.AllScansCompleteFlag = False
	
	'setBandSweepAndScan(band,      start,     stop,      BandMargin,  NoPoints,  rbw
	currentStart = BandMonRec(1) * 1e6
	CurrentStop  = BandMonRec(2) * 1e6

	'Sweep the current selected band
	setBandSweepAndScan(BandMonRec(0), BandMonRec(1), BandMonRec(2), BandMonRec(11),  BandMonRec(10), Main.Band_Data.SigSrcCurrentRecord.RBW_Khz)
End Sub


''--------------------------------------------------------------------------------------------
''Estimate the RxTime for characters
'Private Sub estimateRxTime(noOfPoints As Int) As Int
'	Return (noOfPoints * 37 + 21) * 10000 / networkPars.BaudRate 
'End Sub


'--------------------------------------------------------------------------------------------
'This sub sends out a sweep command to sweep the points in a band
' It is a resumable sub and uses completion functions to signal to 
' other application modules
Public Sub setBandSweepAndScan(band As Int, start As Double, _
	stop As Double, BandMargin As Double, NoPoints As Int, rbw As String)
	'Construct the frequency strings
	Dim startStr As String
	Dim stopStr As String

	scanDataStreamText = ""
	noValidScanLines = 0
	Main.noScanBytesTotalExpected = networkPars.NO_CHARS_IN_SCAN_RESPONSE_PER_LINE * NoPoints + networkPars.NO_CHARS_IN_SCAN_RESPONSE_TERMINATION
	Main.noScanBytesReceived = 0
	
	bandNo = band
	
	'Format the frequency int an integer in Hz
	start = start * 1e6
	startStr = NumberFormat2(start, 1, 0, 0 , False)
	
	stop = stop * 1e6
	stopStr = NumberFormat2(stop, 1, 0, 0 , False)
	
	' Sweep the band
	Main.dataReceivedFlag = False

	cmd = "scan"
	commandStr = cmd & " " & startStr & " " & stopStr & " " & NoPoints & " " & 3
	noOfPackets = 0
	Main.writeCmdSerial(commandStr)
	Main.dataReceivedFlag = False
End Sub


''--------------------------------------------------------------------------------------------
'Private Sub logMultiBandScanData
'
'	For k = 0 To Main.Band_Data.noPointsInTot - 1
'		Dim mbsc As multiBandCsanRecord
'		mbsc.Initialize
''		Log(k &  ", "  & mbsc.Band  &  ", "  & mbsc.Freq & ", "  & mbsc.dBM)
'	Next
'End Sub


'--------------------------------------------------------------------------------------------
Public Sub clearMultiBandScanRecord(noToClear As Int)
	If noToClear > 2000 Then
		noToClear = 2000
	End If
	
	For k = 0 To noToClear - 1
		Dim mbsc As multiBandCsanRecord
		mbsc.Initialize
		mbsc = Main.MultiBandScanData(k)
		mbsc.Band = -1
		mbsc.Freq = 0
		mbsc.dBM = 0
	Next
End Sub

'--------------------------------------------------------------------------------------------
'Populates the multi-band scanned data list from the SA scan return data
'Also does a running mean of the data if the user specifies a  nember gt 1 
'for a number of averages.
'The data fields of the data store in the list are 
'(0) = band no from 0 to no of bands - 1
'(1) = frequency in Hz of spectrum point
'(2) = signal amplitude in dBm
' If the SA sends bad data then this is filterred from the statistics.
Private Sub getScanListFromSaResult(data As String)
	Dim rx As RegexBuilder
	Dim bandStatsArrayIndex As Int
	rx.Initialize.AppendStartString.StartCapture.Append(rx.CharAny).AppendAtLeastOne.EndCapture
	Dim m As Matcher = Regex.Matcher2(rx.Pattern, Regex.MULTILINE, data) 'MULTILINE = StartString and EndString match the beginning and end of each line.

	outArrayCount = 0
	noBandPointsFound = 0

	runCount = runCount + 1
	
	'Initialise the statisitcs record array index for this scan
	bandStatsArrayIndex = 0
		
	'Loop over all of the scanpoint lines and extract the data
	Do While m.Find
		Dim item As String
		Dim startWordIndex As Int = 1
	
		Dim itemFloat(2) As Float
		item = m.Group(1)
		
		If item.Contains("infinity") Then
			Log("Infinity found")
		End If

		startWordIndex = 1
		
		If item.Length > 32 Then
			'Get the frequency value
			itemFloat(0) = sf.SplitGetWord(item, " ", startWordIndex)
			
			Try
				itemFloat(1) = sf.SplitGetWord(item, " ", startWordIndex + 1)
			Catch
				errorCount = errorCount + 1
			End Try	
			
			Try			
				Dim mbsr As multiBandCsanRecord
				mbsr.Initialize
				
				Try
					mbsr = Main.MultiBandScanData(scanListIndex)
				Catch
					Log(LastException)
				End Try	
				
				
				'Calc the running mean
				mbsr.dBM = (mbsr.dBM + (noAverageCount + 1) * itemFloat(1)) / (noAverageCount + 1)
				mbsr.Band = bandNo
				mbsr.Freq = itemFloat(0)
				Main.MultiBandScanData(scanListIndex) = mbsr
				bandStatsValueArray(bandStatsArrayIndex) = mbsr.dBM
				
				If bandStatsValueArray(bandStatsArrayIndex) < -130 Then 'Debug
					bandStatsValueArray(bandStatsArrayIndex) = -130
				End If
				
				bandStatsArrayIndex = bandStatsArrayIndex + 1
				outArrayCount = outArrayCount  + 1
				noBandPointsFound = noBandPointsFound + 1
			Catch
'				Log("2 RunCount = " & runCount & ", ErrorCount = " & errorCount & ", % Error = " & (errorCount / errorCount * 100) & " DataLine = " & item)
			End Try	
			
			scanListIndex = scanListIndex + 1
			
			If scanListIndex = 5000 Then
'				Log("ScanListIndexOverrun")
			End If
		End If
	Loop
	
	'Update the band stats and if we have a trigger type change or a routine log trigger
	'  add a band log record to the DB, but only if log data is checked
	If bandStatsUpdate = True Then
		Toast.TMShow("Update of Band Exception DB failed", True, True)
	End If
	
	totalScans = totalScans + 1
	Main.lblBand.Text = totalScans
End Sub


'--------------------------------------------------------------------------------------------
'This sub initialises the band log record ready to accept exception data
Private Sub bandLogRecordInit
	For bk = 0 To Main.Band_Data.noBandsInTotal - 1
		Private item(12) As Object
		bandLogRecord(bk).MaxSignal_dBm 		= 0				
		bandLogRecord(bk).MinSignal_dBm 		= 0				
		bandLogRecord(bk).MeanSignal_dBm 		= 0			
		bandLogRecord(bk).TriggerType 			= 0			
		bandLogRecord(bk).ExcptnDurationMax1 	= 0	
		bandLogRecord(bk).ExcptnDurationMax2  	= 0
		bandLogRecord(bk).ExcptnDurationMin1  	= 0
		bandLogRecord(bk).ExcptnDurationMin2	= 0
		bandLogRecord(bk).ExcptnDurationNoSig	= 0
		bandLogRecord(bk).unixEpoch 			= DateTime.Now  'Set exact unix time
		bandLogRecord(bk).SignalSourceID 		= Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID 'Set the Signal source ID
		item 									= Main.Band_Data.MbandArrayList.Get(bk)
		bandLogRecord(bk).MonitorChRec_ID 		= item(0)       'Set the current band number scanned
		bandLogRecord(bk).MinHysterysis			= item(8)		'Get the maximum vale hysterisis
		bandLogRecord(bk).MaxHysterysis			= item(9)		'Get the maximum vale hysterisis
	Next
End Sub


'--------------------------------------------------------------------------------------------
private Sub initBandLogRecordTemp
	bandLogRecordTemp.MaxSignal_dBm = -1e6
	bandLogRecordTemp.MinSignal_dBm = 1e6
	bandLogRecordTemp.TriggerType = 0
End Sub


'--------------------------------------------------------------------------------------------
'Calculates the stats max, min and mean for the band for the current band scan
private Sub bandStatsUpdate As Boolean
	
	Dim npts As Int
	'Clear the 
	initBandLogRecordTemp

	Try		
    	'Create the stats across the spectrum aray ------------------------------------------
		npts = Main.Band_Data.getBandNoPointsArray(bandIndexLast)
		
		For i = 0 To npts - 1
			If bandLogRecordTemp.MaxSignal_dBm < bandStatsValueArray(i) Then
				bandLogRecordTemp.MaxSignal_dBm = bandStatsValueArray(i)
			End If
			
			If bandLogRecordTemp.MinSignal_dBm > bandStatsValueArray(i) Then
				bandLogRecordTemp.MinSignal_dBm = bandStatsValueArray(i)
			End If
			
			'Do mean 
			bandLogRecordTemp.MeanSignal_dBm = bandLogRecordTemp.MeanSignal_dBm + bandStatsValueArray(i)
		Next
	
		bandLogRecordTemp.MeanSignal_dBm = bandLogRecordTemp.MeanSignal_dBm / npts
	
		'Calc the mean across the averages - thius will be used at the
		'  end of the average run to process exceptions
		bandLogRecord(bandIndexLast).MeanSignal_dBm = (bandLogRecord(bandIndexLast).MeanSignal_dBm + (noAverageCount + 1) * bandLogRecordTemp.MeanSignal_dBm) / (noAverageCount + 1)
		bandLogRecord(bandIndexLast).MaxSignal_dBm  = (bandLogRecord(bandIndexLast).MaxSignal_dBm  + (noAverageCount + 1) * bandLogRecordTemp.MaxSignal_dBm)  / (noAverageCount + 1)
		bandLogRecord(bandIndexLast).MinSignal_dBm  = (bandLogRecord(bandIndexLast).MinSignal_dBm  + (noAverageCount + 1) * bandLogRecordTemp.MinSignal_dBm)  / (noAverageCount + 1)
		Return False
	Catch
		Return True
	End Try
End Sub


'--------------------------------------------------------------------------------------------
' This sub, executed after each average, examines values returned by the 
'  Tiny Spectrum Analyser and sets the appropriate bits in the bandLogRecord(bk).TriggerType. 
'  On the first average it does not detect changes in state,
'  it simply records the state and if set records the start time and then 
'  produces an "initial" log for each band.
Public Sub processExceptions
	Dim bandExceptions As exceptionLevels_Type
'	Private bitMask As Int
	Private Hmax As Float
	Private Hmin As Float

	bandExceptions.Initialize

	Select 1
		Case 1
			'Use mean of max signal as trigger
			For bk = 0 To Main.Band_Data.noBandsInTotal - 1
				Hmax = bandLogRecord(bk).MaxHysterysis
				Hmin = bandLogRecord(bk).MinHysterysis
				bandExceptions = Main.Band_Data.getExceptionRecord(bk)
				
				'Do the max limits  --------------------------------------------
				If bandLogRecord(bk).MaxSignal_dBm > bandExceptions.Max2 Then
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, max2Bit)
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, max1Bit)

				else if bandLogRecord(bk).MaxSignal_dBm > bandExceptions.Max1 And bandLogRecord(bk).MaxSignal_dBm < (bandExceptions.Max2 - Hmax) Then
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(max2Bit))
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, max1Bit)
					
				else if	bandLogRecord(bk).MaxSignal_dBm < (bandExceptions.Max1 - Hmax) Then
'					bitMask = Bit.Not(max2Bit)
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(max2Bit))
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType,  Bit.Not(max1Bit))
				End If				
				
				
				'Do the min limits  --------------------------------------------
				If bandLogRecord(bk).MaxSignal_dBm < bandExceptions.NoSignal Then
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, noSigBit)
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, min2Bit)
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, min1Bit)
					
				else If bandLogRecord(bk).MaxSignal_dBm > (bandExceptions.NoSignal + Hmin) And bandLogRecord(bk).MaxSignal_dBm < bandExceptions.Min2 Then
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(noSigBit))
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, min2Bit)
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, min1Bit)
					
				else If bandLogRecord(bk).MaxSignal_dBm > (bandExceptions.Min2 + Hmin) And bandLogRecord(bk).MaxSignal_dBm < bandExceptions.Min1 Then
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(noSigBit))
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(min2Bit))
					bandLogRecord(bk).TriggerType = Bit.Or(bandLogRecord(bk).TriggerType, min1Bit)

				
				else If bandLogRecord(bk).MaxSignal_dBm > (bandExceptions.Min1  + Hmin) Then
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(noSigBit))
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(min2Bit))
					bandLogRecord(bk).TriggerType = Bit.And(bandLogRecord(bk).TriggerType, Bit.Not(min1Bit))
				End If
				
				'See if we have changed exception state ------------------------------------------
				If firstAvgDone = False Then
					'Check if any Trigger bits have been set and update the
					'Exception duration field in the exception record ---------------------------
					durationTimerControl(bk)
					
					'Create an initial exception report
					If Main.chkLoggData.Checked = True Then
						Main.rtDB.insertBandExceptionRecord(bk)
					End If
					
					'Set the trigger type states to 
					TriggerType0(bk) = bandLogRecord(bk).TriggerType
				Else
					TriggerType1(bk) = bandLogRecord(bk).TriggerType
					
'					If bk = 0 Then
'						Log("T1 = " & TriggerType1(bk) & "  T2 = "  & TriggerType0(bk))
'					End If

					If TriggerType1(bk)  <> TriggerType0(bk) Then
						'Check if any Trigger bits have been set/reset and update the
						'Exception duration field in the exception record ---------------------------
						durationTimerControl(bk)
							
						'Create an exception report for the releveant bits and channel
						If Main.chkLoggData.Checked = True Then
							Main.rtDB.insertBandExceptionRecord(bk)
						End If
						'Update Trigger0
						TriggerType0(bk)  = TriggerType1(bk)
					End If
				End If
			Next
	End Select	
	'Set the flag for first run complete
	firstAvgDone = True
End Sub



'--------------------------------------------------------------------------------------------
'This sub examines the state of the exception Trigger bits. If a bit is set it records the 
' "start" time. If the bit is clear it records the cuttent time - start time in the log records
' as the duration the bit has been set. It then clears the start time to zero to ease
' debugging

Private Sub durationTimerControl(bi As Int)

	If 	firstAvgDone = True Then
		Private bit0 As Int
		Private bit1 As Int
	
		' See if Max1Bit reset
		bit1 = Bit.And(bandLogRecord(bi).TriggerType, max1Bit)
		bit0 = Bit.And(TriggerType0(bi), max1Bit)
		
		If bit0 <> bit1 Then
			If bit0 = 1 And bit1 = 0 Then
				'Exception cleared
				bandLogRecord(bi).ExcptnDurationMax1 = (DateTime.Now - startExceptionArray(bi).Max1Time) / 1000
				
				#if DEBUG
				startExceptionArray(bi).Max1Time = 0
				#END IF	
			Else
				'Exception period commenced
				startExceptionArray(bi).Max1Time = DateTime.Now
			End If
		End If
		
		' See if Max2Bit reset
		bit1 = Bit.And(bandLogRecord(bi).TriggerType, max2Bit)
		bit0 = Bit.And(TriggerType0(bi), max2Bit)
		
		If bit0 <> bit1 Then
			If bit0 = 2 And bit1 = 0 Then
				'Exception cleared
				bandLogRecord(bi).ExcptnDurationMax2 = (DateTime.Now - startExceptionArray(bi).Max2Time) / 1000
				#if DEBUG
				startExceptionArray(bi).Max2Time = 0
				#END IF
			Else
				'Exception period commenced
				startExceptionArray(bi).Max2Time = DateTime.Now
			End If
		End If	
			
		' See if Min1Bit reset
		bit1 = Bit.And(bandLogRecord(bi).TriggerType, min1Bit)
		bit0 = Bit.And(TriggerType0(bi), min1Bit)
		
		If bit0 <> bit1 Then
			If bit0 = 4 And bit1 = 0 Then
				'Exception cleared
				bandLogRecord(bi).ExcptnDurationMin1 = (DateTime.Now - startExceptionArray(bi).Min1Time) / 1000
				#if DEBUG
				startExceptionArray(bi).Min1Time = 0
				#END IF				
			Else
				'Exception period commenced
				startExceptionArray(bi).Min1Time = DateTime.Now
			End If
		End If	
		
		' See if Min2Bit reset
		bit1 = Bit.And(bandLogRecord(bi).TriggerType, min2Bit)
		bit0 = Bit.And(TriggerType0(bi), min2Bit)
		
		If bit0 <> bit1 Then
			If bit0 = 8 And bit1 = 0 Then
				'Exception cleared
				bandLogRecord(bi).ExcptnDurationMin2 = (DateTime.Now - startExceptionArray(bi).Min2Time) / 1000
				#if DEBUG
				startExceptionArray(bi).Min2Time = 0
				#END IF				
			Else
				'Exception period commenced
				startExceptionArray(bi).Min2Time = DateTime.Now
			End If
		End If
		
		' See if Min2Bit reset
		bit1 = Bit.And(bandLogRecord(bi).TriggerType, noSigBit)
		bit0 = Bit.And(TriggerType0(bi), noSigBit)
		
		If bit0 <> bit1 Then			
			If bit0 = 16 And bit1 = 0 Then
				'Exception cleared
				bandLogRecord(bi).ExcptnDurationNoSig = (DateTime.Now - startExceptionArray(bi).NoSignalTime) / 1000
				#if DEBUG
				startExceptionArray(bi).NoSignalTime = 0
				#END IF				
			Else
				'Exception period commenced
				startExceptionArray(bi).NoSignalTime = DateTime.Now
			End If
		End If	
	Else
		'On first run through only set the start time of "set" bits
		If Bit.And(bandLogRecord(bi).TriggerType, max1Bit) = 1 Then
			startExceptionArray(bi).Max1Time = DateTime.Now
		End If
		
		If Bit.And(bandLogRecord(bi).TriggerType, max2Bit) = 2 Then
			startExceptionArray(bi).Max2Time = DateTime.Now
		End If
		
		If Bit.And(bandLogRecord(bi).TriggerType, min1Bit) = 4 Then
			startExceptionArray(bi).Min1Time = DateTime.Now
		End If
		
		If Bit.And(bandLogRecord(bi).TriggerType, min2Bit) = 8 Then
			startExceptionArray(bi).Min2Time = DateTime.Now
		End If
		
		If Bit.And(bandLogRecord(bi).TriggerType, noSigBit) = 16 Then
			startExceptionArray(bi).NoSignalTime = DateTime.Now
		End If
	End If	
End Sub

'
''--------------------------------------------------------------------------------------------
'Private Sub updatePointProgressBar
'	Dim pct As Double
'	Dim noPointsComplete As Int
'	
'	noPointsComplete = Main.Band_Data.noPointsComplet
'	noPointsComplete = noPointsComplete + 1
'	pct = noPointsComplete / Main.Band_Data.noPointsInTot
'	Main.Band_Data.noPointsComplet = noPointsComplete
''	Main.progBandScan.Progress = pct
'	Sleep(0)
'End Sub


'--------------------------------------------------------------------------------------------
Private Sub updateAverageProgressBar
	Dim pct As Double
	
	pct = (noAverageCount + 1) / (Main.Band_Data.NoAveragesToDo)
	Main.progAverage.Progress = pct
	Sleep(1)
End Sub



'--------------------------------------------------------------------------------------------
Public Sub create_dBm_CurveForPlotting
	Dim k As Int = 0  'Index into output array
	Dim bNum0 As Int  'Detect change in band
	Dim bNum1 As Int  ' "            "
	
	Main.CurrentSpectrum(k) = Main.ConstyMin
	k = k + 1
	Main.CurrentSpectrum(k) = Main.ConstyMin
	k = k + 1
	
	Dim mbsr0 As multiBandCsanRecord
	mbsr0.Initialize
	
	mbsr0 = Main.MultiBandScanData(0)
	bNum0 = mbsr0.Band
	bNum1 = mbsr0.Band
	
	For r = 0 To Main.Band_Data.noPointsInTot - 1
		Dim mbsr As multiBandCsanRecord
		mbsr.Initialize
		
		mbsr = Main.MultiBandScanData(r)
		bNum0 = mbsr.Band
		
		If bNum1 <> bNum0 Then
			bNum1 = bNum0
			Main.CurrentSpectrum(k) = Main.ConstyMin
			k = k + 1
			Main.CurrentSpectrum(k) = Main.ConstyMin
			k = k + 1
			Main.CurrentSpectrum(k) = Main.ConstyMin
		End If
		
		Main.CurrentSpectrum(k) = mbsr.dBM
		k = k + 1
	Next
	
	Main.CurrentSpectrum(k) = Main.ConstyMin
	k = k + 1
	Main.CurrentSpectrum(k) = Main.ConstyMin
	k = k + 1
	Main.CurrentSpectrum(k) = Main.ConstyMin
End Sub


'--------------------------------------------------------------------------------------------
Public Sub zeroErrorCounters
	errorCount = 0
	runCount = 0
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getErrorCounter  As Int
	Return errorCount
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getRunCounter  As Int
	Return runCount
End Sub



'--------------------------------------------------------------------------------------------
Public Sub createRunExceptionIndex(comment As String, details As String)
	bandExceptionIndex.StartUnixEpoch = DateTime.Now
	bandExceptionIndex.StartDateTimeUTC = DateTime.Date(bandExceptionIndex.StartUnixEpoch) & " " & DateTime.Time(bandExceptionIndex.StartUnixEpoch)
	bandExceptionIndex.SignalSource_ID = Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID
	bandExceptionIndex.Comment = comment
	bandExceptionIndex.Details = details
	bandExceptionIndex.Deleted = 0
	Main.rtDB.insertRunExceptionIndex
End Sub