﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Type tag_T(txf As B4XView, fieldValue As String, dirty As Boolean, error As Boolean)
	Type comboTag_T(cmb As B4XComboBox, cmbIndex As Int, parent As String, dirty As Boolean)
	Type formTag_T(formName As String, dirty As Boolean)
	Type checkBoxTag_T(chkBox As CheckBox, chkBoxName As String, value As Boolean, dirty As Boolean)
		
	Private fx As JFX
	Private xui As XUI
	Private Toast As clXToastMessage
	Private comboTagList As List
	Private contParentPanes As Map
	Private mCallbackStrInput As String
	Private mCallbackStrReset As String
	Private mCallback As Object
	Private fm As Form
	Private globalDirtyFlag As Boolean
	
	Public CheckBoxBlockingFlag As Boolean
End Sub


'============================================================================================
'Initializes the object. You can add parameters to this method if needed.
'Do this when all user inpout controls have been loaded for a particular form
Public Sub Initialize(f As Object, fname As Form, formName As String, callbackStrInput As String, callbackStrReset As String)

	Dim formTag As formTag_T
	formTag.formName = formName
	formTag.dirty = False
	
	mCallback = f
	mCallbackStrInput  = callbackStrInput
	mCallbackStrReset  = callbackStrReset
	
	comboTagList.Initialize
	contParentPanes.Initialize
	
	
	Dim fm As Form = fname
	setUserInputControlTagsInit(fm, False, False)

	Toast.Initialize(fm.RootPane)
	Toast.SetTMPosition(Toast.TMPOS_BOTTOM)
	Toast.SetTMDuration(1000, 8000) 
	Toast.SetTMBackground(0xFFFFF4A8, 2, 0xFF000000, 3)
	Toast.SetTMTextProp(36, 1, 1, 0xFFFF0000)
End Sub


'============================================================================================
Public Sub setGlobalDirty(gdirty As Boolean)
	globalDirtyFlag = gdirty
End Sub


'============================================================================================
Public Sub getGlobalDirty As Boolean
	Return globalDirtyFlag
End Sub


'============================================================================================
Public Sub setChkBoxBlockFlag(bf As Boolean)
	CheckBoxBlockingFlag = bf
End Sub


'============================================================================================
Public Sub getChkBoxBlockFlag As Boolean
	Return CheckBoxBlockingFlag
End Sub


'============================================================================================
Private Sub callBackInput(arg1 As Object, arg2 As Object) As Object
	
	If  SubExists(mCallback, mCallbackStrInput) Then
		Return CallSub3(mCallback, mCallbackStrInput, arg1, arg2)
	End If
	Return  "no sub"	
End Sub


'============================================================================================
Private Sub callBackReset(arg1 As Object, arg2 As Object) As Object
	
	If  SubExists(mCallback, mCallbackStrReset) Then
		Return CallSub3(mCallback, mCallbackStrReset, arg1, arg2)
	End If
	Return  "no sub"	
End Sub


'============================================================================================
Public Sub addParentPaneToList(paneControl As Pane)
	contParentPanes.Put(paneControl.Tag, paneControl)
End Sub


'============================================================================================
Public Sub clearDisabledPanes
	Private pane As Pane
	
	For i = 0 To contParentPanes.Size - 1
		pane = contParentPanes.GetValueAt(i)
		pane.Enabled = True
		pane.Alpha = 1.0
	Next
End Sub


'============================================================================================
Public Sub checkCombo(cmb As B4XComboBox, parent As String, f As Form) As Boolean
	Private comboTagTemp As comboTag_T
	comboTagTemp.Initialize
	comboTagTemp = cmb.Tag
	
	If comboTagTemp.cmbIndex <> cmb.SelectedIndex Then
		comboTagTemp.dirty = True
'		comboTag.cmbIndex = cmb.SelectedIndex
		cmb.cmbBox.Style = "-fx-background-color: #F6FF74;-fx-border-color: #ADADAD;-fx-border-width: 1;-fx-border-radius: 2;"
	Else
		comboTagTemp.dirty = False
		cmb.cmbBox.Style =  "-fx-background-color: #FFFFFF;-fx-border-color: #ADADAD;-fx-border-width: 1;-fx-border-radius: 2;"
	End If
	
	cmb.Tag = comboTagTemp
	

	disableOtherControlPanes(comboTagTemp.parent)
	
	Return comboTagTemp.dirty
End Sub


''============================================================================================
'Private Sub GetParent(v As B4XView) As B4XView
'	Dim r As Reflector
'	r.Target = v
'	Return r.RunMethod("getParent")
'End Sub


'============================================================================================
Public Sub isAnyComboDirty(parent As String) As Boolean
	Private comboTagTemp As comboTag_T
	comboTagTemp.Initialize
	
	For i = 0 To comboTagList.Size - 1
		comboTagTemp = comboTagList.Get(i)
		
		If comboTagTemp.parent.CompareTo(parent) = 0 Then
			If comboTagTemp.dirty = True Then
				Return True
			End If
		End If
	Next
	Return False
End Sub


'============================================================================================
Public Sub restoreComboValues(parent As String)
	Private comboTagTemp As comboTag_T
	Private cmb As B4XComboBox
	comboTagTemp.Initialize
	
	For i = 0 To comboTagList.Size - 1
		comboTagTemp = comboTagList.Get(i)
		
		If comboTagTemp.parent.CompareTo(parent) = 0 Then
			If comboTagTemp.dirty = True Then
				comboTagTemp.dirty = False
				cmb = comboTagTemp.cmb
				cmb.SelectedIndex = comboTagTemp.cmbIndex
				cmb.Tag = comboTagTemp
				cmb.cmbBox.Style =  "-fx-background-color: #FFFFFF;-fx-border-color: #ADADAD;-fx-border-width: 1;-fx-border-radius: 2;"
			End If
		End If
	Next
End Sub


'============================================================================================
Public Sub disableOtherControlPanes(panel As String)
	Private paneTemp As Pane
	Private keyTemp As String
	
	For i = 0 To contParentPanes.Size - 1
		keyTemp = contParentPanes.GetKeyAt(i)
		If keyTemp.CompareTo(panel) <> 0 Then
			paneTemp = contParentPanes.GetValueAt(i)
			paneTemp.Enabled = False
			paneTemp.Alpha = 0.5
		Else
			paneTemp = contParentPanes.GetValueAt(i)
			paneTemp.Enabled = True
			paneTemp.Alpha = 1
		End If
	Next
End Sub


'============================================================================================
Public Sub checkNum(txf As B4XView, isNum As Boolean, minVal As Float, maxVal As Float, _ 
				    varName As String,  f As Form, regexMatch As String) As Boolean
	Private tagTemp As tag_T
	Private chkBoxTagTemp As checkBoxTag_T
	Private chkBoxTemp As CheckBox
	Private parentPane As Pane
	
	If txf Is TextField  And txf.Tag <> "" Then
		tagTemp.Initialize
		tagTemp = txf.Tag

		If isControlDirty(f, txf) Then
			parentPane= txf.Parent
'			tagTemp.dirty = True
			txf.SetColorAndBorder(0xFFF6FF74, 1, 0xFFADADAD, 1)
			disableOtherControlPanes(txf.Parent.Tag)
			
			Dim ptag As Object = parentPane.Tag
			
			callBackInput(ptag, Null)
		End If
		
		'Do numeric checks for number fields
		If isNum = True Then
			If  Not(IsNumber(txf.Text)) Then
				Toast.TMShow("Error: " & varName & " is not a number", True, True)
				tagTemp.error = True
				txf.Tag = tagTemp
				txf.SetColorAndBorder(0xFFFFA3A3, 1, 0xFFADADAD, 2)
				Return True
			End If
			
			If txf.Text < minVal Then
				Toast.TMShow("Error: " & varName & "  is less than " & minVal, True, True)
				tagTemp.error = True
				txf.Tag = tagTemp
				txf.SetColorAndBorder(0xFFFFA3A3, 1, 0xFFADADAD, 2)
				Return True
			End If
			
			If txf.Text > maxVal Then
				Toast.TMShow("Error: " & varName & " is greater than " & maxVal, True, True)
				tagTemp.error = True
				txf.Tag = tagTemp
				txf.SetColorAndBorder(0xFFFFA3A3, 1, 0xFFADADAD, 2)
				Return True
			End If
			
		Else if txf.Text.Length < minVal Then
				Toast.TMShow("Error: " & varName & " length is less than " & minVal, True, True)
				tagTemp.error = True
				txf.Tag = tagTemp
				txf.SetColorAndBorder(0xFFFFA3A3, 1, 0xFFADADAD, 2)
				Return True

		Else if txf.Text.Length > maxVal Then
			Toast.TMShow("Error: " & varName & "  length is greater than " & maxVal, True, True)
			tagTemp.error = True
			txf.Tag = tagTemp
			txf.SetColorAndBorder(0xFFFFA3A3, 1, 0xFFADADAD, 2)
			Return True
			
		Else If regexMatch.Length > 0 Then
			'TODO
			tagTemp.error = True
			txf.Tag = tagTemp
		End If
		
		tagTemp.error = False
		txf.Tag = tagTemp
	
	Else If txf Is CheckBox And Not(txf.Tag = "" Or txf.Tag = Null) Then
		chkBoxTagTemp.Initialize
		chkBoxTemp = txf
		chkBoxTagTemp = chkBoxTemp.Tag
		
		If isControlDirty(f, chkBoxTemp) Then
			parentPane= chkBoxTemp.Parent
'			chkBoxTagTemp.dirty = True
			chkBoxTemp.Tag = chkBoxTagTemp
			
			txf.SetColorAndBorder(0xFFF6FF74, 1, 0xFFADADAD, 2)
			disableOtherControlPanes(txf.Parent.Tag)
			
			Dim ptag As Object = parentPane.Tag
			
			callBackInput(ptag, Null)
		End If
	End If
	Return False
End Sub


'============================================================================================
public Sub addCombo(cmb As B4XComboBox, cmbParent As String, value As String, error As Boolean, dirty As Boolean)
	Private cmbTag As comboTag_T
	cmbTag.Initialize
	
	cmbTag.cmb 		= cmb
	cmbTag.parent 	= cmbParent
	
	Try
		cmbTag.cmbIndex = cmb.SelectedIndex
	Catch
		cmbTag.cmbIndex = -1 'Invalid index
	End Try	
	
	cmbTag.dirty	= dirty
	cmb.Tag = cmbTag

	comboTagList.Add(cmbTag)
End Sub


'============================================================================================
public Sub focusHasChanged(txf As B4XView, hasFocus As Boolean)
	If hasFocus = True Then
		txf.Tag = txf.Text
	End If
End Sub


'===========================================================================================
Private Sub setUserInputControlTagsInit(f As Form, error As Boolean, dirty As Boolean)
	For Each n As Node In f.RootPane.GetAllViewsRecursive
		Private tagStruct As tag_T
		Private chkBoxTagTemp As checkBoxTag_T
		Private txf As B4XView
		Private chkBoxTemp As CheckBox
		
		tagStruct.Initialize
		chkBoxTagTemp.Initialize
		
		If n Is TextField And n.Tag <> "" Then
			txf = n
'			Log(n.Tag)
			tagStruct.txf = txf
			tagStruct.fieldValue = "v9r5S@S#Y&CzzUqR" 'Random character string
			tagStruct.dirty = dirty
			tagStruct.error = error
			n.Tag = tagStruct
			tagStruct = n.Tag

			contParentPanes.Put(tagStruct.txf.Parent.Tag, tagStruct.txf.Parent)
			
			
		else if n Is CheckBox And n.Tag <> "" Then
			chkBoxTemp = n
'			Log(n.Tag)
			chkBoxTagTemp.chkBoxName = n.Tag
			chkBoxTagTemp.chkBox = chkBoxTemp
			chkBoxTagTemp.dirty = dirty
			chkBoxTagTemp.value = chkBoxTemp.Checked
			
			chkBoxTemp.Tag = chkBoxTagTemp
'			n.Tag = chkBoxTagTemp
			chkBoxTagTemp = n.Tag
			
			contParentPanes.Put(chkBoxTagTemp.chkBox.Parent.Tag, chkBoxTagTemp.chkBox.Parent)
			
'			Log("CheckBox Found")
		End If
	Next
End Sub


'===========================================================================================
'Do this ONLY after the setUserInputControlTagsInit has been executed
'Used to exclude non-user input fields from error and dirty checking
Public Sub setUserInputControlTag(f As Form,  txf As B4XView, value As Object, error As Boolean, dirty As Boolean)
	Dim tagStruct As tag_T
	Dim chkBoxTag As checkBoxTag_T

	
	If txf Is TextField Then	
		tagStruct.Initialize
		tagStruct.fieldValue = value
		tagStruct.dirty = dirty
		tagStruct.error = error

	Else If txf Is CheckBox	And txf.Tag <> "" Then
		chkBoxTag.Initialize
		chkBoxTag.value = value
		chkBoxTag.dirty = dirty
	End If	
	
	txf.Tag = tagStruct
		
'	    tagStruct = txf.Tag
'		Log(tagStruct.fieldName)
End Sub


'===========================================================================================
Public Sub doWeHaveErrors(f As Form, parent As Pane, parentStr As String) As Boolean
	Private tagTemp As tag_T
	tagTemp.Initialize	
	
	For Each n As Node In f.RootPane.GetAllViewsRecursive		
		If n Is TextField And n.Parent = parent And n.Tag <> Null Then
			Try 
				tagTemp = n.Tag
				
				If tagTemp.error = True Then
'					Log(tagTemp.fieldName)
					Return True
				End If	
			Catch
				Log(LastException)
			End Try
		End If
	Next
	Return False
End Sub


'============================================================================================
Public Sub isFormDirty(f As Form, parent As Pane, parentStr As String) As Boolean
	Private tagTemp As tag_T
	tagTemp.Initialize
	
	'Check the text fields
	For Each n As Node In f.RootPane.GetAllViewsRecursive
		If n Is TextField And n.Parent = parent And n.Tag <> Null Then
			Try
				tagTemp = n.Tag
				
				If tagTemp.dirty = True Then
					Return True
				End If
			Catch
				Log(LastException)
			End Try
		End If
	Next
	
	'Check the combo boxes
	Return isAnyComboDirty(parentStr)
End Sub


'============================================================================================
Public Sub restorePreviousValues(f As Form, parent As Pane, parentStr As String)
	Private tagTemp As tag_T
	Private checkBoxTagTemp As checkBoxTag_T
	Private checkBoxTemp As CheckBox
	Private txf As B4XView
	tagTemp.Initialize

	
	'Check the text fields
	For Each n As Node In f.RootPane.GetAllViewsRecursive
		txf = n
		If n Is TextField And n.Parent = parent And n.Tag <> Null Then
			Try
				tagTemp = n.Tag
				
				If tagTemp.dirty = True Then
					tagTemp.dirty = False
					txf.Text = tagTemp.fieldValue
					txf.Tag = tagTemp
					txf.SetColorAndBorder(0xFFFFFFFF, 1, 0xFFADADAD, 2)
				End If
			Catch
				Log(LastException)
			End Try

		else if n Is CheckBox And n.Tag <> "" Then
			checkBoxTemp = n
			checkBoxTagTemp = checkBoxTemp.Tag
			If checkBoxTagTemp.chkBoxName <> "" Then
				If checkBoxTagTemp.dirty = True Then
					checkBoxTagTemp.dirty = False
					checkBoxTemp.Checked = checkBoxTagTemp.value
					checkBoxTemp.Tag = checkBoxTagTemp
					txf.SetColorAndBorder(0xFFFFFFFF, 1, 0xFFADADAD, 2)
				End If
			End If
		End If	
	Next
	
	'Check the combo boxes
	restoreComboValues(parentStr)
	parent.Enabled = True
	callBackReset(Null, Null)
End Sub

'===========================================================================================
Public Sub setUserInputControlTags(f As Form, parent As Pane,  parentStr As String, error As Boolean, dirty As Boolean)
	For Each n As Node In f.RootPane.GetAllViewsRecursive
		Dim tagStruct As tag_T
		Dim chkBoxTag As checkBoxTag_T
		
		Dim txf As B4XView
		Dim chkBoxTemp As CheckBox

		tagStruct.Initialize
		
		If n Is TextField And n.Parent = parent And n.Tag <> Null Then
			txf = n
			tagStruct = txf.Tag
			tagStruct.fieldValue = txf.Text
			tagStruct.dirty = dirty
			tagStruct.error = error
			txf.Tag = tagStruct

			If error = True Then
				txf.SetColorAndBorder(0xFFFD8989, 1, 0xFF939393, 2)
			else if dirty = True Then
				txf.SetColorAndBorder(0xFFF6FF74, 1, 0xFF939393, 2)
			Else
				txf.SetColorAndBorder(0xFFFFFFFF, 1, 0xFF939393, 2)
			End If
			
		else if n Is CheckBox And n.Tag <> "" Then	
			chkBoxTemp = n
			chkBoxTag = chkBoxTemp.Tag
			chkBoxTag.value = chkBoxTemp.Checked
			chkBoxTag.dirty = dirty
			chkBoxTemp.Tag = chkBoxTag
		End If
	Next
	
	If dirty = False Then
		callBackReset(Null, Null)
	End If
End Sub


'===========================================================================================
' This function checks text fields,  check boxes for changes. If the data is different
' from the tag structure the "dirty" flag for the control element is set True and the 
' background color is highlighted and the "old" value is stored in the tag structure
Public Sub isControlDirty(f As Form, txf As B4XView) As Boolean
	Private tagTemp As tag_T	
	Private chkBoxTag As checkBoxTag_T
	Private chkBoxTemp As CheckBox
	Dim tagStr As String
	Dim controlText As String
	Dim result As Boolean
	
	If txf Is TextField Then
		Try 
			tagTemp.Initialize
			tagTemp = txf.Tag
	'		Log(tagTemp.fieldName)
			
			If tagTemp.dirty = False Then
				tagStr			= tagTemp.fieldValue.Trim
				controlText		= txf.Text.Trim
				
				If tagStr.CompareTo(controlText) <> 0 Then
					tagTemp.dirty = True
					txf.Tag = tagTemp
				End If	
			End If
		Catch
			Log(LastException)
		End Try
		result = tagTemp.dirty

	else if txf Is CheckBox And txf.Tag <> "" Then
		chkBoxTemp = txf
		chkBoxTag.Initialize
		chkBoxTag = txf.Tag
			
		If tagTemp.dirty = False Then
			If chkBoxTag.value = Not(chkBoxTemp.Checked) Then
				chkBoxTag.dirty = True
				txf.Tag = chkBoxTag
			End If
		End If
		result = chkBoxTag.dirty
	End If	
	Return result
End Sub


'===========================================================================================
Public Sub ifChanged(f As Form, txf As B4XView) As Boolean
	Private tagTemp As tag_T	
	
	tagTemp = txf.Tag
	Return tagTemp.dirty

End Sub


'===========================================================================================
Public Sub revertTextFieldsToTag(f As Form)
	Private tagTemp As tag_T
	Dim tf As TextField
	
	For Each n As Node In f.RootPane.GetAllViewsRecursive
		If n Is TextField Then
			Try
				tagTemp = n.Tag

				If tagTemp.dirty = True Then
					tf = n.As(TextField)
					tf.Text = tagTemp.fieldValue
				End If
				
				tagTemp.fieldValue = ""
				tagTemp.dirty = False
				n.Tag = tagTemp
			Catch
				Log(LastException)
			End Try
		End If
	Next
End Sub

