﻿B4J=true
Group=Default Group\GraphsAndAnalysis
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	
	Type exceptionLevels_Type ( _
								Max1 As Float, _
								Max2 As Float, _
								Min1 As Float, _
								Min2 As Float, _
								NoSignal As Float, _
								TriggerType As Int _
								)
	
	Private exceptionData(50) As exceptionLevels_Type

	Private fx As JFX
	Private sqlBand_Data As SQL
	
	Public SigSrcCurrentRecord As SigSourceRec_Type

	Public specSurfaceX As List
	Private noPointsInGraph As Int
	Public bandPtFreqList As List
	Public bandPtValuedBm As List

	Public MbandArrayList As List			'Contains list of monitored bands for the selected Signal Source record
	Private mBandNoPointsArray(100) As Int
	Public timeStampTicksList As List
	Private bpInPtr As Int
'	Private bpOutPtr As Int
	Private noBandsTotal As Int
	Private noPointsTotal As Int
	Private noPointsComplete As Int

	Private ns As Int
	Private np As Int
	
	Public xList As List
End Sub


'--------------------------------------------------------------------------------------------
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	bandPtFreqList.Initialize
	timeStampTicksList.Initialize
	specSurfaceX.Initialize
	bandPtValuedBm.Initialize

	MbandArrayList.Initialize
End Sub


'--------------------------------------------------------------------------------------------
public Sub createSpectrumList(nBands As Int, noPoints As List, frequencies As List, _ 
							  spectFreqList As List, noSamples As Int, left As Double, _ 
							  width As Double, f0 As Double, fn As Double)
	ns = noSamples
	np = spectFreqList.Size
	
	Dim c As Double
	Dim a As Double
	
	Dim totalPoints As Int
	Dim v As Object
	For Each v In noPoints
		v = noPoints.Get(0)
		totalPoints = totalPoints + v
	Next
	
	bpInPtr = 0
'	bpOutPtr = 0
	
	'Make a 2D array large enough for all the spectrum analyser points
	'Make the row
	Dim ptArray As Object
	Private valuePtArraytemp(spectFreqList.Size) As Int
	
	For i = 0 To spectFreqList.Size - 1
		valuePtArraytemp(i) = Main.ConstyMin
	Next
	
	' Make the last column zero for the normalisation of the color map data
	valuePtArraytemp(spectFreqList.Size - 1) = 0.0
	
	'Make the record set
	bandPtValuedBm.Clear
	
	For i = 0 To noSamples - 1
		bandPtValuedBm.Add(valuePtArraytemp)
	Next
	
	specSurfaceX.Clear
	a = (width - 6) / (fn - f0)
	
	For i = 0 To np - 1
'		Dim xv As Object
		Dim x As Int
		Dim f As Object

		f = spectFreqList.Get(i)
		If i = 130 Then
			np = spectFreqList.Size
		End If
'		x = Floor(a * (f - f0) + left)
		x = a * (f - f0) + left
		If i = totalPoints - 1 Then
			x = Floor(left + width) - 1
		End If
		specSurfaceX.Add(x)
	Next
	
	bandPtFreqList = spectFreqList
	
	For i = 0 To totalPoints - 1
		valuePtArraytemp(i) = 0
	Next
	
	' Set the timestamp
	ptArray = valuePtArraytemp
		
	For i = 0 To noSamples - 1
		timeStampTicksList.Add(ptArray)
	Next
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getSpectrumPointsForPlotting As Double()
	Return Main.CurrentSpectrum
End Sub



'--------------------------------------------------------------------------------------------
Public Sub plotSpectrumOnMainGraph
	For i = 0 To Main.Band_Data.noPointsGraph
		Main.xG_ChBandsMain.CurveY(6,i) = Main.Band_Data.SpectrumPointsForPlotting(i)
	Next
	Main.xG_ChBandsMain.DrawGraph
End Sub



'----------------------------------------------------------------------------------
public Sub plotBarGraphMain
'	Private sf As StringFunctions
	
	Main.xBarTab1.ClearData
'	Private MaxSig As Double
'	Private MinSig As Double
'	Private MeanSig As Double
	Private bstats As band_stats_Type
	bstats.Initialize

	' add the bars
	Main.xBarTab1.AddBar("Max", xui.Color_Red)
	Main.xBarTab1.AddBar("Min", xui.Color_Blue)
	Main.xBarTab1.AddBar("Mean", xui.Color_Green)
	
	Private range As Double = networkPars.MainBarGraphMinValue - Main.Band_Data.SigSrcCurrentRecord.RefLevel

	For k = 0 To xList.Size - 1
		bstats.MaxSignal_dBm = -range + SaCom.bandLogRecord(k).MaxSignal_dBm * range / networkPars.MainBarGraphMinValue
		
		If bstats.MaxSignal_dBm < -5 Then 
			bstats.MaxSignal_dBm = -5
		End If
		
		bstats.MinSignal_dBm = -range + SaCom.bandLogRecord(k).MinSignal_dBm * range / networkPars.MainBarGraphMinValue
		
		If bstats.MinSignal_dBm < -5 Then
			bstats.MinSignal_dBm = -5
		End If
		
		bstats.MeanSignal_dBm = -range + SaCom.bandLogRecord(k).MeanSignal_dBm * range / networkPars.MainBarGraphMinValue
		
		If bstats.MeanSignal_dBm < -5 Then
			bstats.MeanSignal_dBm = -5
		End If
		
		Main.xBarTab1.AddBarMultiplePoint(xList.Get(k), Array As Double( _
														bstats.MaxSignal_dBm, _
														bstats.MinSignal_dBm, _
														bstats.MeanSignal_dBm))
	Next
	
	Main.xBarTab1.DrawChart
	Sleep(0)
End Sub

'--------------------------------------------------------------------------------------------
Public Sub createBandNoPointsArray
	Dim k As Int = 0
	
	Try
	For Each record() As Object In MbandArrayList
		mBandNoPointsArray(k) = record(10)
		k = k + 1
	Next
	Catch
		Log("createBandNoPointsArray Error")
	End Try	
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getBandNoPointsArray(k As Int) As Int
	Return 	mBandNoPointsArray(k)
End Sub


'--------------------------------------------------------------------------------------------
Public Sub createExceptionRecordArray
	Dim k As Int = 0
	
	For Each record() As Object In MbandArrayList
		exceptionData(k).Max1 			= record(3)
		exceptionData(k).Max2 			= record(4)
		exceptionData(k).Min1 			= record(5)
		exceptionData(k).Min2 			= record(6)
		exceptionData(k).NoSignal 		= record(7)
		exceptionData(k).TriggerType 	= 0
		k = k + 1
	Next
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getExceptionRecord(k As Int) As exceptionLevels_Type
	Return 	exceptionData(k)
End Sub


'--------------------------------------------------------------------------------------------
Public Sub insertSpectrumRecord(timestamp As Long, ptArray() As Float)
	Dim sp As Object
	Dim ts As Object
	
	sp = ptArray
	bandPtFreqList.Set(bpInPtr, sp)
	
	ts = timestamp
	timeStampTicksList.Set(bpInPtr, ts)
	
	'Update input ptr
	bpInPtr = bpInPtr + 1
	
	If bpInPtr >= ns Then
		bpInPtr = 0
	End If
End Sub


'--------------------------------------------------------------------------------------------
Public Sub setnoBandsInTotal(nb As Int)
	noBandsTotal = nb
End Sub

'--------------------------------------------------------------------------------------------
Public Sub getnoBandsInTotal As Int
	Return noBandsTotal
End Sub



'--------------------------------------------------------------------------------------------
Public Sub setnoPointsInTot(npts As Int)
	noPointsTotal = npts
End Sub

'--------------------------------------------------------------------------------------------
Public Sub getnoPointsInTot As Int
	Return noPointsTotal
End Sub



'--------------------------------------------------------------------------------------------
Public Sub setnoPointsGraph(nptsg As Int)
	noPointsInGraph = nptsg
End Sub

'--------------------------------------------------------------------------------------------
Public Sub getnoPointsGraph As Int
	Return noPointsInGraph
End Sub




'--------------------------------------------------------------------------------------------
Public Sub setnoPointsComplet(nptscp As Int)
	noPointsComplete = nptscp
End Sub

'--------------------------------------------------------------------------------------------
Public Sub getnoPointsComplet As Int
	Return noPointsComplete
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getAllSpectrumRecords As List
	Return bandPtFreqList
End Sub


'--------------------------------------------------------------------------------------------
Public Sub getAllTimeStamps As List
	Return timeStampTicksList
End Sub



'--------------------------------------------------------------------------------------------
Public Sub getNoAveragesToDo As Int
	Return SigSrcCurrentRecord.NoSpectrumAvgs
End Sub



'--------------------------------------------------------------------------------------------
Public Sub getSampleTimeToDo As Int
	Return SigSrcCurrentRecord.SampleTime
End Sub
'--------------------------------------------------------------------------------------------
Public Sub createBand_DataBase
	If sqlBand_Data.IsInitialized = False Then
		Dim qryStr As String
		
		Try
			sqlBand_Data.InitializeSQLite("",":memory:", True)
		Catch
			Log(LastException)
		End Try
		
		qryStr = "PRAGMA auto_vacuum = 1"
		
		Try
			sqlBand_Data.ExecNonQuery(qryStr)
		Catch
			Log("mcuClient Line 634" & LastException)
		End Try
		
		qryStr = _
		$"CREATE TABLE tblBand_Data (
   	 		MonitoredDataID  INTEGER PRIMARY KEY,
   	 		BandNo           INTEGER,
    		tblMonitoredChID INTEGER,
    		PointNo          INTEGER,
    		AmplitudedBm     DOUBLE);"$

		Try
			sqlBand_Data.ExecNonQuery(qryStr)
		Catch
			Log("mcuClient Line 652" & LastException)
		End Try
	End If
End Sub


'--------------------------------------------------------------------------------------------
public Sub getNoSamples As Int
	Return ns
End Sub


'--------------------------------------------------------------------------------------------
public Sub setMbandList(bList As List)
	MbandArrayList = bList
End Sub

'--------------------------------------------------------------------------------------------
public Sub getMbandList  As List
	Return MbandArrayList
End Sub


'--------------------------------------------------------------------------------------------
public Sub clearMbandArrayList
	MbandArrayList.clear
End Sub

