﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	Private xui As XUI
	
	Type SigSourceRec_Type( _
	       	SignalSource_ID 		As Int, _
			SignalName 				As String, _
			SignalBandStart_MHz 	As Double, _
			SignalBandStop_MHz 		As Double, _
			Comment 				As String, _
			DateCreated 			As String, _
			DateUsed 				As String, _
			InUse 					As Boolean, _
			DateAccessed 			As String, _
			NoPoints 				As Int, _
			SampleTime 				As Double, _
			LNA_On 					As String, _
			LNA_Gain 				As String, _
			Attenuator 				As String, _
			RBW_Khz 				As String, _
			RefLevel 				As String, _
			NoSpectrumAvgs 			As Int, _
			RoutineDataFrequencyN 	As Int _
			)
	
	Type MonitoredSignalPars_Type( _
		 tfChID  				As Int, _
		 tfStartMHz 			As Double, _
		 tfStopMHz 				As Double, _ 
		 tfMax1dBm 				As Double, _ 
		 tfMax2dBm 				As Double, _ 
		 tfMin1dBm 				As Double, _ 
		 tfMin2dBm 				As Double, _ 
		 tfNoSignaldBm 			As Double, _ 
		 tfMinHystdBm 			As Double, _ 
		 tfMaxHystdbM 			As Double, _
		 NoPoints 				As Int, _
		 BandMarginMHz 			As Double, _
		 SampleTime 			As Double, _
		 LNA_On					As String, _
		 LNA_Gain				As String, _
		 Attenuator				As String, _
		 RBW_kHz 				As String)

	Private MSArray As MonitoredSignalPars_Type
	Private MSRecordSelected As MonitoredSignalPars_Type

	Public noSpectrumPoints As Int
End Sub


'======================================================================================================
'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(tabNo As Int, tbl1 As TableView, tbl2 As TableView)
	Main.Band_Data.SigSrcCurrentRecord.Initialize
	MSArray.Initialize
	MSRecordSelected.Initialize
	
	clearSigSourceRecord

	Select tabNo
	Case 1
		
	Case 2		
		
	Case 3
		' Init tables and text fields with signal and monitor data
		tbl1.SetColumnWidth(0, 25) 'Sig ID
		tbl1.SetColumnWidth(1, 170) 'Sig Name
		tbl1.SetColumnWidth(2, 65) 'Start MHz
		tbl1.SetColumnWidth(3, 65) 'Stop MHz
		tbl1.SetColumnWidth(4, 75) 'RBW
		tbl1.SetColumnWidth(5, 60) 'Ref Level
		tbl1.SetColumnWidth(6, 45) 'LNA On
		tbl1.SetColumnWidth(7, 35) 'Att
		tbl1.SetColumnWidth(8, 50) 'No Averages
		tbl1.SetColumnWidth(9, 90) 'Comment
		tbl1.SetColumnWidth(10, 135) 'Created
		tbl1.SetColumnWidth(11, 45) 'InUse
		tbl1.SetColumnWidth(12, 65) 'Save N

		tbl2.SetColumnWidth(0, 25) 'InUse
		tbl2.SetColumnWidth(1, 170) 'InUse
		tbl2.SetColumnWidth(2, 80) 'InUse
		tbl2.SetColumnWidth(3, 65) 'InUse
		tbl2.SetColumnWidth(5, 65) 'InUse
		tbl2.SetColumnWidth(6, 65) 'InUse
		tbl2.SetColumnWidth(7, 65) 'InUse
		tbl2.SetColumnWidth(8, 65) 'InUse
		tbl2.SetColumnWidth(10, 65) 'InUse
		tbl2.SetColumnWidth(11, 65) 'InUse
		tbl2.SetColumnWidth(12, 65) 'InUse
		
		Main.tblChannelsMain.SetColumnWidth(0, 180)
		Main.tblChannelsMain.SetColumnWidth(1, 110)
		Main.tblChannelsMain.SetColumnWidth(2, 110)
		
		'Set up the monitor bands chart
End Select
End Sub


'======================================================================================================
public Sub clearSigSourceRecord
	Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID 		= 0
	Main.Band_Data.SigSrcCurrentRecord.SignalName 			= ""
	Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz 	= 0
	Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz  	= 0
	Main.Band_Data.SigSrcCurrentRecord.Comment				= ""
	Main.Band_Data.SigSrcCurrentRecord.DateCreated			= ""
	Main.Band_Data.SigSrcCurrentRecord.DateUsed				= ""
	Main.Band_Data.SigSrcCurrentRecord.InUse 				= False
	Main.Band_Data.SigSrcCurrentRecord.DateAccessed			= ""
	Main.Band_Data.SigSrcCurrentRecord.NoPoints				= 1
	Main.Band_Data.SigSrcCurrentRecord.SampleTime			= 0.5
	Main.Band_Data.SigSrcCurrentRecord.LNA_On				= "on"
	Main.Band_Data.SigSrcCurrentRecord.LNA_Gain				= "auto"
	Main.Band_Data.SigSrcCurrentRecord.Attenuator			= 0
	Main.Band_Data.SigSrcCurrentRecord.RBW_Khz				= "10k"
	Main.Band_Data.SigSrcCurrentRecord.RefLevel				= 0
	Main.Band_Data.SigSrcCurrentRecord.NoSpectrumAvgs		= 1
	Main.Band_Data.SigSrcCurrentRecord.RoutineDataFrequencyN = 5
	
	Main.textSignalSrcID.Text 			= ""
	Main.textSignalSourceName.Text 		= ""
	Main.textBandStart.Text 			= ""
	Main.textBandStop.Text 				= ""
	Main.textNoAverages.Text 			= ""
	Main.textRefLevel.Text 				= ""
	Main.txfNoPoints.Text	 			= ""
	Main.textLogRatio.Text 				= ""
	Main.TextSignalComment.Text	 		= ""
	Main.textSampleTime.Text 			= ""
	Main.comboRBW.SelectedIndex			= 0
	Main.comboAttSetting.SelectedIndex	= 0
	
'	Main.textSignalSrcID.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textSignalSourceName.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textBandStart.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textBandStop.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textNoAverages.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textRefLevel.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.txfNoPoints.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textLogRatio.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.TextSignalComment.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.textSampleTime.SetColorAndBorder(0xFFFFFFFF, 0, 0, 0)
'	Main.comboRBW.SelectedIndex			= 0
'	Main.comboAttSetting.SelectedIndex	= 0
	
End Sub


'======================================================================================================
public Sub clearMonChannelUserInputFields
	Main.tfChID.Text				= ""
	Main.tfChName.Text				= ""
	Main.tfSigSrcID.Text			= ""
	Main.tfCreatedDate.Text			= ""
	Main.tfStartMHz.Text			= ""
	Main.tfStopMHz.Text				= ""
	Main.tfMax1dBm.Text				= ""
	Main.tfMax2dBm.Text				= ""
	Main.tfMin1dBm.Text				= ""
	Main.tfMin2dBm.Text				= ""
	Main.tfNoSignaldBm.Text			= ""
	Main.tfMinHystdBm.Text			= ""
	Main.tfMaxHystdbM.Text			= ""
	Main.tfComment.Text				= ""
	Main.tfNoPoints	.Text			= ""
	Main.tfBandMarginMHz.Text		= ""
	Main.userCheck.setUserInputControlTag(Main.MainForm, Main.textSignalSrcID, "", False, False)
	Main.userCheck.setUserInputControlTag(Main.MainForm, Main.tfChID, "", False, False)
End Sub


'======================================================================================================
public Sub clearMonitoredChannelRecord

	clearMonChannelUserInputFields
	Main.tableMonitoredChannels.Items.Clear
	Main.tblChannelsMain.Items.Clear

	hideGraphs
End Sub


'======================================================================================================
Public Sub hideGraphs
	Main.panexGChBands.Visible = False
	Main.paneXGraph.Visible = False
	Main.paneBarChart.Visible = False
	
	Main.lblNoBandsTab3.Visible = True
	Main.lblNoBandsTab1.Visible = True
	Main.lblBarGraphNoPlot.Visible = True
End Sub


'======================================================================================================
Public Sub showGraphs
	Main.panexGChBands.Visible = True
	Main.paneXGraph.Visible = True
	Main.paneBarChart.Visible = True
	
	Main.lblNoBandsTab3.Visible = False
	Main.lblNoBandsTab1.Visible = False
	Main.lblBarGraphNoPlot.Visible = False
End Sub


'======================================================================================================
Public Sub fillSignalSourceList(tbl1 As TableView) As Boolean
	Dim rset As ResultSet
	Dim tempStr As String
	tbl1.Items.Clear
	
	'Set this to block the CheckBox changed sub on programatic changes.
	Main.userCheck.ChkBoxBlockFlag = True
	
	rset = Main.rtDB.getSignalSourceRecords(0)
	
	'Populate the user entry fields with the first record
	Main.textSignalSourceName.Text 	= rset.GetString2(1)
	Main.textSignalSrcID.Text		= NumberFormat2(rset.GetString2(0), 1, 0, 0, False)
	
	Main.textSignalSourceNameTab1.Text 	= rset.GetString2(1)
	Main.textSignalSrcIDTab1.Text		= NumberFormat2(rset.GetString2(0), 1, 0, 0, False)
	
	Main.textBandStart.Text 		= NumberFormat2(rset.GetString2(2), 1, 7, 1,False)
	Main.textBandStop.Text 			= NumberFormat2(rset.GetString2(3), 1, 7, 1,False)
	
	tempStr = rset.GetString2(14)

'	Dim indexTemp As Int = Main.comboRBW.IndexOf(tempStr)
	Main.comboRBW.SelectedIndex = Main.comboRBW.IndexOf(tempStr)
	
	Main.chkLNA_On.Checked = True
	If tempStr.CompareTo("on") = 0 Then
		Main.chkLNA_On.Checked = True
	End If
	
	tempStr = rset.GetString2(13)
	
	Main.comboAttSetting.SelectedIndex = Main.comboAttSetting.IndexOf(tempStr)
	
	Main.textRefLevel.Text 			= rset.GetString2(15)
	Main.textNoAverages.Text 		= rset.GetInt2(16)
	Main.textLogRatio.Text			= rset.GetInt2(17)
	Main.TextSignalComment.Text 	= rset.GetString2(4)
	Main.txfNoPoints.Text			= rset.GetInt2(9)
	Main.textSampleTime.Text		= rset.GetDouble2(10)
	
	Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID 	= rset.GetInt2(0)
	
	If Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID <= 0 Then
		Return True
	End If
	
	Main.Band_Data.SigSrcCurrentRecord.SignalName 				= rset.GetString2(1)
	Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz 		= rset.GetDouble2(2)
	Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz  		= rset.GetDouble2(3)
	Main.Band_Data.SigSrcCurrentRecord.Comment					= rset.GetString2(4)
	Main.Band_Data.SigSrcCurrentRecord.DateCreated				= rset.GetString2(5)
	Main.Band_Data.SigSrcCurrentRecord.DateUsed					= rset.GetString2(6)
	
	Main.Band_Data.SigSrcCurrentRecord.InUse = False
	If rset.GetInt2(7) = 1 Then
		Main.Band_Data.SigSrcCurrentRecord.InUse	= True
	End If	
	
	Main.Band_Data.SigSrcCurrentRecord.DateAccessed				= rset.GetString2(8)
	Main.Band_Data.SigSrcCurrentRecord.NoPoints					= rset.GetInt2(9)
	Main.Band_Data.SigSrcCurrentRecord.SampleTime				= rset.GetDouble2(10)
	
	Main.Band_Data.SigSrcCurrentRecord.LNA_On 					= rset.GetString2(11)
	Main.Band_Data.SigSrcCurrentRecord.LNA_Gain 				= rset.GetString2(12)
	Main.Band_Data.SigSrcCurrentRecord.Attenuator 				= rset.GetString2(13)
	Main.Band_Data.SigSrcCurrentRecord.RBW_Khz 					= rset.GetString2(14)
	Main.Band_Data.SigSrcCurrentRecord.RefLevel 				= rset.GetString2(15)
	Main.Band_Data.SigSrcCurrentRecord.NoSpectrumAvgs 			= rset.GetInt2(16)

	Main.Band_Data.SigSrcCurrentRecord.RoutineDataFrequencyN 	= rset.GetInt2(17)
	
	' Set the userCheck values to the current record values and the input field eror/dirty tags
	Main.userCheck.setUserInputControlTags(Main.MainForm, Main.paneControlPars, "paneControlPars", False, False)

	Main.Band_Data.SigSrcCurrentRecord.InUse = False
	If rset.GetInt2(7) = 1 Then
		Main.Band_Data.SigSrcCurrentRecord.InUse = True
	End If
	
	'Populate the Signal Source Table
	Do While rset.NextRow 
		Dim values(rset.ColumnCount) As String
		values(0) = NumberFormat2(rset.GetString2(0), 1, 0, 0,False) 	'ID
		values(1) = rset.GetString2(1)									'Name
		values(2) = NumberFormat2(rset.GetString2(2), 1, 7, 1, False)	'Start MHz
		values(3) = NumberFormat2(rset.GetString2(3), 1, 7, 1, False)	'Stop MHz
		values(4) = rset.GetString2(14) 	'RBW
		values(5) = NumberFormat2(rset.GetString2(15), 1, 0, 0, False)  'Ref Level
		values(6) = rset.GetString2(11) 								'LNA on
		values(7) = rset.GetString2(13)									'Attenuator
		values(8) = NumberFormat2(rset.GetString2(16), 1, 0, 0, False)  'N Avg
		values(9) = rset.GetString2(4)									'Comment
		values(10) = rset.GetString2(5)									'Created
		values(12) = NumberFormat2(rset.GetString2(7), 1, 0, 0, False) 'In use 
		values(13) = NumberFormat2(rset.GetString2(17), 1, 0, 0, False) 'In use

		If rset.GetString2(7) = "1" Then 
			values(11) = "True"
		Else
			values(11) = "False"
		End If
		tbl1.Items.Add(values)
	Loop
	
'	signalSrcTableSelectedIndex = Index
'	signalSrcTableSelectedRow = Row
'	
	Return False
End Sub


'======================================================================================================
public Sub fillMonitoredBandsList(tbl2 As TableView) As Boolean
	Dim rset As ResultSet
	Dim nBandsTemp As Int = 0
	Dim nPointsTemp As Int = 0
	tbl2.Items.Clear

	'Clear the input field eror/dirty tags
	Main.Band_Data.clearMbandArrayList
	
	'Check the filter parameter
	If Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID <= 0 Then
		Return True
	End If
	
	Main.Band_Data.noBandsInTotal = 0
	
	'All good lets get the monitored channels if any
	Try
		rset = Main.rtDB.getMonitoredChannelRecords(Main.Band_Data.SigSrcCurrentRecord.SignalSource_ID)
	Catch
		Main.Toast.TMShow("There are no monitored channels set for this Signal Source", True, True)
		Return True
	End Try	

	'Populate the user entry fields with the first record
	Try
		Main.tfChID.Text 				= rset.GetInt2(0)			'ID
	Catch
		Log(LastException)
		Return True
	End Try	
		
	If rset.GetInt2(0) <= 0 Then
		Return True
	End If
	
	Main.tfChName.Text				= rset.GetString2(1)		'Name
	Main.tfSigSrcID.Text			= rset.GetInt2(2)			'Sig Src ID
	Main.tfCreatedDate.Text			= rset.GetString2(3)		'Created Date
	Main.tfStartMHz.Text			= rset.GetDouble2(4)		'Start MHz
	Main.tfStopMHz.Text				= rset.GetDouble2(5)		'Stop MHz
	Main.tfMax1dBm.Text				= rset.GetDouble2(6)		'Max 1
	Main.tfMax2dBm.Text				= rset.GetDouble2(7)		'Max 2
	Main.tfMin1dBm.Text				= rset.GetDouble2(8)		'Min 1
	Main.tfMin2dBm.Text				= rset.GetDouble2(9)		'Min 2
	Main.tfNoSignaldBm.Text			= rset.GetDouble2(10)		'No Sig
	Main.tfMinHystdBm.Text			= rset.GetDouble2(11)		'MinHyst
	Main.tfMaxHystdbM.Text			= rset.GetDouble2(12)		'Max Hist
	Main.tfComment.Text				= rset.GetString2(13)		'Commant
	Main.tfNoPoints	.Text			= rset.GetInt2(14)			'No Points
	Main.tfBandMarginMHz.Text		= rset.GetDouble2(15)		'Band Margin
	
	'Intialise the recovery (undo) data/flags
	Main.userCheck.setUserInputControlTags(Main.MainForm, Main.monBandPane, "monBandPane", False, False)
	
	'Populate the Monitored Channel Array
	
	'Populate the Signal Source Table
	Dim listTemp As List
	listTemp.Initialize
	
	Do While rset.NextRow
		nBandsTemp = nBandsTemp + 1
		Dim values(13) As String
		Dim valuesList(13) As Object
		Dim tblChMainValues(3) As String
	
			values(0) 			= rset.GetInt2(0)		'tfChID.
			values(1) 			= rset.GetString2(1)	'Name
			values(2)			= rset.GetDouble2(4)	'Start MHz
			values(3)			= rset.GetDouble2(5)	'Stop MHz
			values(4)			= rset.GetDouble2(6)	'Max 1
			values(5)			= rset.GetDouble2(7)	'Max 2
			values(6)			= rset.GetDouble2(8)	'Min 1
			values(7)			= rset.GetDouble2(9)	'Min 2
			values(8)			= rset.GetDouble2(10)	'No Sig
			values(9)			= rset.GetDouble2(11)	'Min H
			values(10)			= rset.GetDouble2(12)	'Max H
			values(11)			= rset.GetInt2(14)		'No Points
			values(12)			= rset.GetDouble2(15)	'Band Margin
		
		 valuesList(0) 			= rset.GetInt2(0)		'tfChID.
		 valuesList(1)			= rset.GetDouble2(4)	'Start MHz
		 valuesList(2)			= rset.GetDouble2(5)	'Stop MHz
		 valuesList(3)			= rset.GetDouble2(6)	'Max 1
		 valuesList(4)			= rset.GetDouble2(7)	'Max 2
		 valuesList(5)			= rset.GetDouble2(8)	'Min 1
		 valuesList(6)			= rset.GetDouble2(9)	'Min 2
		 valuesList(7)			= rset.GetDouble2(10)	'No Sig
		 valuesList(8)			= rset.GetDouble2(11)	'Min H
		 valuesList(9)			= rset.GetDouble2(12)	'Max H
		 valuesList(10)			= rset.GetInt2(14)		'No Points
		 valuesList(11)			= rset.GetDouble2(15)	'Band Margin
		 valuesList(12)			= rset.GetString2(1)	'Name
		 
		tblChMainValues(0) 		= rset.GetString2(1)
		tblChMainValues(1)		= rset.GetDouble2(4)	'Start MHz
		tblChMainValues(2)		= rset.GetDouble2(5)	'Stop MHz
		
		 
		nPointsTemp = nPointsTemp + rset.GetInt2(14)

		tbl2.Items.Add(values)
		listTemp.Add(valuesList)
		Main.tblChannelsMain.Items.Add(tblChMainValues)
	Loop
	Main.Band_Data.noBandsInTotal = nBandsTemp
	
	Main.Band_Data.MbandList = listTemp			'Save the monitored points list 
	Main.Band_Data.createBandNoPointsArray	 	'Make an array of the no of point per band to speed things up
	Main.Band_Data.createExceptionRecordArray	'Make an array of exception data per band to speed things up
	Main.Band_Data.noPointsInTot = nPointsTemp
	
	Return False
End Sub


'----------------------------------------------------------------------------------
'Initilise the Band Graph
public Sub bandGraphCfgInit
'	Private i As Int
'	Private Nbx As Int
	Private xPtr As Int
'	Private lastBandmax As Double
	Private const missingData As Double = 1e20
	Dim nBands As Int
	Dim noPointsList As List
	Dim freqList As List
	Dim spectFreqList As List
	
	noPointsList.Initialize
	freqList.Initialize
	spectFreqList.Initialize
	Main.SpectrumFreqList.Clear
	
	Main.xG_ChBands.NbMaxCurves = 6
	Main.xG_ChBands.GraphWithMissingData = True
	
	Main.xG_ChBands.UseCustomColors = True
	Main.xG_ChBands.Title = "Signal Bands"
	
	Main.xG_ChBands.noYNames = True
	
	
	' band and limit traces
	Main.xG_ChBands.CurveYName(0) = "" '"Band Envelope"
	Main.xG_ChBands.SetScaleManu(0, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(0) = 0xFF0066FF
	Main.xG_ChBands.CurveCustomWidth(0) = 4dip
	Main.xG_ChBands.NbYIntervals = 12

	Main.xG_ChBands.CurveYName(1) = ""  '"Max 1 dBm"
	Main.xG_ChBands.SetScaleManu(1, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(1) = 0xFF96A4FF
	Main.xG_ChBands.CurveCustomWidth(1) = 2dip
	
	Main.xG_ChBands.CurveYName(2) = "" '"Max 2 dBm"
	Main.xG_ChBands.SetScaleManu(2, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(2) = 0xFF3350FD
	Main.xG_ChBands.CurveCustomWidth(2) = 2dip
	
	Main.xG_ChBands.CurveYName(3) = ""  '"Min 1 dBm"
	Main.xG_ChBands.SetScaleManu(3, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(3) = 0xFFFB9D9E
	Main.xG_ChBands.CurveCustomWidth(3) = 2dip
	
	Main.xG_ChBands.CurveYName(4) = "" '"Min 2 dBm"
	Main.xG_ChBands.SetScaleManu(4, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(4) = 0xFFFF1A1D
	Main.xG_ChBands.CurveCustomWidth(4) = 2dip
	
	Main.xG_ChBands.CurveYName(5) = ""  '"No Signal dBm"
	Main.xG_ChBands.SetScaleManu(5, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBands.CurveColor(5) = 0xFFDC1AFF
	Main.xG_ChBands.CurveCustomWidth(5) = 2dip


	Main.xG_ChBands.CurvesToDisplay.Initialize2(Array As Int(0, 1, 2, 3, 4, 5))
'	Main.xG_ChBands.CurvesToDisplay.Initialize2(Array As Int(0))

	
	'Create x data

	xPtr = 0
	Main.xG_ChBands.CurveX(xPtr) = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
	Main.xG_ChBands.CurveY(0,xPtr) = Main.ConstyMin
	Main.xG_ChBands.CurveY(1,xPtr) = missingData
	Main.xG_ChBands.CurveY(2,xPtr) = missingData
	Main.xG_ChBands.CurveY(3,xPtr) = missingData
	Main.xG_ChBands.CurveY(4,xPtr) = missingData
	Main.xG_ChBands.CurveY(5,xPtr) = missingData
	
'	lastBandmax = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
	xPtr = xPtr + 1
	nBands = 0
	
	Dim bList As List
	bList.Initialize

	bList = Main.Band_Data.MbandList

	For Each item() As Object In bList
		Dim pt As Int
		Dim delta As Double
		Dim xValue As Double
		Dim fi As Object
		
		noPointsList.Add(item(10))
		nBands = nBands + 1

		delta = (item(2) - item(1)) / item(10)
		
		For pt = 0 To item(10) - 1
			If pt = 0 Then
				xValue = item(1) - delta
				Main.xG_ChBands.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
				Main.SpectrumFreqList.Add(f)
				
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBands.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBands.CurveY(1,xPtr) = missingData
				Main.xG_ChBands.CurveY(2,xPtr) = missingData
				Main.xG_ChBands.CurveY(3,xPtr) = missingData
				Main.xG_ChBands.CurveY(4,xPtr) = missingData
				Main.xG_ChBands.CurveY(5,xPtr) = missingData
'				xValue = xValue + delta
			End If
			xPtr = xPtr + 1
			xValue = xValue + delta
			Dim fi As Object
			fi = xValue
			freqList.Add(fi)
			Main.xG_ChBands.CurveX(xPtr) = xValue
			
			Dim f As Object
			f = xValue
			Main.SpectrumFreqList.Add(f)
			
			Main.xG_ChBands.CurveY(0,xPtr) = Main.Band_Data.SigSrcCurrentRecord.RefLevel
			Main.xG_ChBands.CurveY(1,xPtr) = item(3)
			Main.xG_ChBands.CurveY(2,xPtr) = item(4)
			Main.xG_ChBands.CurveY(3,xPtr) = item(5)
			Main.xG_ChBands.CurveY(4,xPtr) = item(6)
			Main.xG_ChBands.CurveY(5,xPtr) = item(7)

			If pt = item(10) - 1 Then
				xValue = xValue + delta
				Main.xG_ChBands.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBands.CurveY(0,xPtr) = Main.Band_Data.SigSrcCurrentRecord.RefLevel
				Main.xG_ChBands.CurveY(1,xPtr) = item(3)
				Main.xG_ChBands.CurveY(2,xPtr) = item(4)
				Main.xG_ChBands.CurveY(3,xPtr) = item(5)
				Main.xG_ChBands.CurveY(4,xPtr) = item(6)
				Main.xG_ChBands.CurveY(5,xPtr) = item(7)
				xPtr = xPtr + 1
				xValue = xValue + delta
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBands.CurveX(xPtr) = xValue
				Main.xG_ChBands.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBands.CurveY(1,xPtr) = missingData
				Main.xG_ChBands.CurveY(2,xPtr) = missingData
				Main.xG_ChBands.CurveY(3,xPtr) = missingData
				Main.xG_ChBands.CurveY(4,xPtr) = missingData
				Main.xG_ChBands.CurveY(5,xPtr) = missingData
				xPtr = xPtr + 1
				xValue = xValue + delta
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
								
				Main.xG_ChBands.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBands.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBands.CurveY(1,xPtr) = missingData
				Main.xG_ChBands.CurveY(2,xPtr) = missingData
				Main.xG_ChBands.CurveY(3,xPtr) = missingData
				Main.xG_ChBands.CurveY(4,xPtr) = missingData
				Main.xG_ChBands.CurveY(5,xPtr) = missingData
'				lastBandmax = xValue
			End If
		Next
	Next

	xPtr = xPtr + 1
	Main.xG_ChBands.CurveX(xPtr) = Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz
	Main.xG_ChBands.CurveY(0,xPtr) = Main.ConstyMin
	Main.xG_ChBands.CurveY(1,xPtr) = missingData
	Main.xG_ChBands.CurveY(2,xPtr) = missingData
	Main.xG_ChBands.CurveY(3,xPtr) = missingData
	Main.xG_ChBands.CurveY(4,xPtr) = missingData
	Main.xG_ChBands.CurveY(5,xPtr) = missingData
	
	Main.xG_ChBands.NbSamples = xPtr + 1
	noSpectrumPoints = Main.xG_ChBands.NbSamples
	Main.xG_ChBands.DrawGraph
	
	f = Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz
	Main.SpectrumFreqList.Add(f)
	
	Main.Band_Data.createSpectrumList(nBands, noPointsList, freqList, _
										Main.SpectrumFreqList, _
										500, _
	 									Main.spectrogram1.SpectrogramLeft, _ 
										Main.spectrogram1.SpectrogramWidth, _
										Main.xG_ChBands.CurveX(0), _
										Main.xG_ChBands.CurveX(noSpectrumPoints - 1))
										
'	Main.spectrogram1.plotSpectrogram(Main.Band_DataSet.specSurfaceX, Main.Band_DataSet.bandPtValuedBm, Main.Band_DataSet.NoSamples)
	Main.Band_Data.noPointsGraph= Main.xG_ChBands.NbSamples
End Sub
'

Private Sub xG_ChBands_CursorPositionChanged (CursorIndex As Int, XIndex As Int)
	
End Sub


'----------------------------------------------------------------------------------
'Initilise the Band Graph
public Sub bandGraphMainInit
'	Private i As Int
'	Private Nbx As Int
	Private xPtr As Int
'	Private lastBandmax As Double
	Private const missingData As Double = 1e20
	Dim nBands As Int
	Dim noPointsList As List
	Dim freqList As List
	Dim spectFreqList As List
	
	noPointsList.Initialize
	freqList.Initialize
	spectFreqList.Initialize
	Main.SpectrumFreqList.Clear
	
	Main.xG_ChBandsMain.NbMaxCurves = 7
	Main.xG_ChBandsMain.GraphWithMissingData = True
	
	
	Main.xG_ChBandsMain.UseCustomColors = False
	Main.xG_ChBandsMain.Title = "Signal Bands"
	
	Dim noYIntervals As Int
	Main.xG_ChBandsMain.noYNames = True

	
	noYIntervals = Main.ConstyMin - Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10
	Main.xG_ChBandsMain.NbYIntervals = noYIntervals
	
	' band and limit traces
	Main.xG_ChBandsMain.CurveYName(0) = "Band Envelope"
	Main.xG_ChBandsMain.SetScaleManu(0, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(0) = 0xFF01A300
	Main.xG_ChBandsMain.CurveWidth(0) = 3dip
	Main.xG_ChBandsMain.NbYIntervals = 12

	Main.xG_ChBandsMain.CurveYName(1) = "Max 1 dBm"
	Main.xG_ChBandsMain.SetScaleManu(1, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(1) = 0xFF0077FF
	Main.xG_ChBandsMain.CurveWidth(1) = 1dip
	
	Main.xG_ChBandsMain.CurveYName(2) = "Max 2 dBm"
	Main.xG_ChBandsMain.SetScaleManu(2, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(2) = 0xFFFF00F2
	Main.xG_ChBandsMain.CurveWidth(2) = 2dip
	
	Main.xG_ChBandsMain.CurveYName(3) = "Min 1 dBm"
	Main.xG_ChBandsMain.SetScaleManu(3, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(3) = 0xFF8CB000
	Main.xG_ChBandsMain.CurveWidth(3) = 1dip
	
	Main.xG_ChBandsMain.CurveYName(4) = "Min 2 dBm"
	Main.xG_ChBandsMain.SetScaleManu(4, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(4) = 0xFFD0B000
	Main.xG_ChBandsMain.CurveWidth(4) = 2dip
	
	Main.xG_ChBandsMain.CurveYName(5) = "No Signal dBm"
	Main.xG_ChBandsMain.SetScaleManu(5, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(5) = 0xFFE80058 'Purple
	Main.xG_ChBandsMain.CurveWidth(5) = 2dip
	
	Main.xG_ChBandsMain.CurveYName(6) = "Current Spectrum"
	Main.xG_ChBandsMain.SetScaleManu(6, Main.ConstyMin, Main.Band_Data.SigSrcCurrentRecord.RefLevel + 10)
	Main.xG_ChBandsMain.CurveColor(6) = 0xFFFF3700  'Red
	Main.xG_ChBandsMain.CurveWidth(5) = 3dip

	Main.xG_ChBandsMain.CurvesToDisplay.Initialize2(Array As Int(0, 1, 2, 3, 4, 5, 6))
'	Main.xG_ChBandsMain.CurvesToDisplay.Initialize2(Array As Int(0))

	
	'Create x data

	xPtr = 0
	Main.xG_ChBandsMain.CurveX(xPtr) = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
	Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.ConstyMin
	Main.xG_ChBandsMain.CurveY(1,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(2,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(3,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(4,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(5,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
	
'	lastBandmax = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
	xPtr = xPtr + 1
	nBands = 0
	
	Dim bList As List
	bList.Initialize
	bList = Main.Band_Data.MbandList
	
	
	For Each item() As Object In bList
		Dim pt As Int
		Dim delta As Double
		Dim xValue As Double
		Dim fi As Object
		noPointsList.Add(item(10))
		nBands = nBands + 1

		delta = (item(2) - item(1)) / item(10)
		
		For pt = 0 To item(10) - 1
			If pt = 0 Then
				xValue = item(1) - delta
				Main.xG_ChBandsMain.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = Main.Band_Data.SigSrcCurrentRecord.SignalBandStart_MHz
				Main.SpectrumFreqList.Add(f)
				
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBandsMain.CurveY(1,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(2,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(3,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(4,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(5,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
'				xValue = xValue + delta
			End If
			xPtr = xPtr + 1
			xValue = xValue + delta
			Dim fi As Object
			fi = xValue
			freqList.Add(fi)
			Main.xG_ChBandsMain.CurveX(xPtr) = xValue
			
			Dim f As Object
			f = xValue
			Main.SpectrumFreqList.Add(f)
			
			Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.Band_Data.SigSrcCurrentRecord.RefLevel
			Main.xG_ChBandsMain.CurveY(1,xPtr) = item(3)
			Main.xG_ChBandsMain.CurveY(2,xPtr) = item(4)
			Main.xG_ChBandsMain.CurveY(3,xPtr) = item(5)
			Main.xG_ChBandsMain.CurveY(4,xPtr) = item(6)
			Main.xG_ChBandsMain.CurveY(5,xPtr) = item(7)
			Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
			
			If pt = item(10) - 1 Then
				xValue = xValue + delta
				Main.xG_ChBandsMain.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.Band_Data.SigSrcCurrentRecord.RefLevel
				Main.xG_ChBandsMain.CurveY(1,xPtr) = item(3)
				Main.xG_ChBandsMain.CurveY(2,xPtr) = item(4)
				Main.xG_ChBandsMain.CurveY(3,xPtr) = item(5)
				Main.xG_ChBandsMain.CurveY(4,xPtr) = item(6)
				Main.xG_ChBandsMain.CurveY(5,xPtr) = item(7)
				Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
				xPtr = xPtr + 1
				xValue = xValue + delta
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBandsMain.CurveX(xPtr) = xValue
				Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBandsMain.CurveY(1,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(2,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(3,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(4,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(5,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
				xPtr = xPtr + 1
				xValue = xValue + delta
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
								
				Main.xG_ChBandsMain.CurveX(xPtr) = xValue
				
				Dim f As Object
				f = xValue
				Main.SpectrumFreqList.Add(f)
				
				Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.ConstyMin
				Main.xG_ChBandsMain.CurveY(1,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(2,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(3,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(4,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(5,xPtr) = missingData
				Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
'				lastBandmax = xValue
			End If
		Next
	Next

	xPtr = xPtr + 1
	Main.xG_ChBandsMain.CurveX(xPtr) = Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz
	Main.xG_ChBandsMain.CurveY(0,xPtr) = Main.ConstyMin
	Main.xG_ChBandsMain.CurveY(1,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(2,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(3,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(4,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(5,xPtr) = missingData
	Main.xG_ChBandsMain.CurveY(6,xPtr) = missingData
	
	Main.xG_ChBandsMain.NbSamples = xPtr + 1
	noSpectrumPoints = Main.xG_ChBandsMain.NbSamples
	Main.xG_ChBandsMain.DrawGraph
	
	f = Main.Band_Data.SigSrcCurrentRecord.SignalBandStop_MHz
	Main.SpectrumFreqList.Add(f)
	
	Main.Band_Data.createSpectrumList(nBands, noPointsList, freqList, _
										Main.SpectrumFreqList, _
										500, _
	 									Main.spectrogram1.SpectrogramLeft, _ 
										Main.spectrogram1.SpectrogramWidth, _
										Main.xG_ChBandsMain.CurveX(0), _
										Main.xG_ChBandsMain.CurveX(noSpectrumPoints - 1))
										
'	Main.spectrogram1.plotSpectrogram(Main.Band_DataSet.specSurfaceX, Main.Band_DataSet.bandPtValuedBm, Main.Band_DataSet.NoSamples)
End Sub


'----------------------------------------------------------------------------------
public Sub initBarGraphMain
	Private sf As StringFunctions
	
	Dim bList As List
	bList.Initialize
	bList = Main.Band_Data.MbandList
	
	Main.xBarTab1.ClearData
	
	Main.xBarTab1.XScaleTextOrientation = "VERTICAL"
	
	' add the bars
	Main.xBarTab1.AddBar("Max", xui.Color_Red)
	Main.xBarTab1.AddBar("Min", xui.Color_Blue)
	Main.xBarTab1.AddBar("Mean", xui.Color_Green)
	
	Main.xBarTab1.AutomaticScale = False
	Main.xBarTab1.YScaleMaxValue =  Main.Band_Data.SigSrcCurrentRecord.RefLevel - networkPars.MainBarGraphMinValue
	Main.xBarTab1.YScaleMinValue = -10
	
	Main.Band_Data.xList.Initialize
	
	Dim k As Int = 0
	
	For Each item() As Object In bList
		Main.Band_Data.xList.Add(sf.SplitGetWord(item(12),  " ", 1))
		k = k + 1
	Next

'	Dim xValues(xList.Size) As String
'	Dim dBmValues(xList.Size, 3) As Double
	
'	Dim xs As String

	For k = 0 To Main.Band_Data.xList.Size - 1
'		xs = xList.Get(k)
		Main.xBarTab1.AddBarMultiplePoint(Main.Band_Data.xList.Get(k), _
						 Array As Double(networkPars.MainBarGraphMinValue - networkPars.MainBarGraphMinValue - 5, _
						    			 networkPars.MainBarGraphMinValue -  networkPars.MainBarGraphMinValue - 5, _ 
										 networkPars.MainBarGraphMinValue -  networkPars.MainBarGraphMinValue - 5))
	Next
	
	Main.xBarTab1.DrawChart
	Sleep(0)
End Sub


'----------------------------------------------------------------------------------
private Sub simulateSpecData
	'Normalise frequency
	Dim c As Double
	Dim a As Double
	
	c = Main.spectrogram1.SpectrogramLeft
	a = Main.spectrogram1.SpectrogramWidth / ((Main.xG_ChBands.CurveX(noSpectrumPoints) - Main.xG_ChBands.CurveX(0)))
End Sub




